Use random password if bootoption 'ssh' doesn't have an option.
[grml-autoconfig.git] / autoconfig.functions
1 #!/bin/zsh
2 # Filename:      autoconfig.functions
3 # Purpose:       basic system configuration and hardware setup for grml system
4 # Authors:       grml-team (grml.org), (c) Klaus Knopper <knopper@knopper.net>, (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see http://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2.
7 # Latest change: Fre Aug 15 23:06:21 CEST 2008 [mika]
8 ################################################################################
9
10 # {{{ path, variables, signals, umask, zsh
11 export PATH="/bin:/sbin:/usr/bin:/usr/sbin:/usr/X11R6/bin"
12 DEBUG="/dev/null"
13 KERNEL="$(uname -r)"
14 umask 022
15
16 # old linuxrc version:
17 [ -d /cdrom ]      && export LIVECD_PATH=/cdrom
18 # new initramfs layout:
19 [ -d /live/image ] && export LIVECD_PATH=/live/image
20
21 # Ignore these signals in non-interactive mode: INT, TERM, SEGV
22 [ -z "$PS1" ] && trap "" 2 3 11
23
24 # zsh stuff
25 iszsh(){
26 if [ -n "$ZSH_VERSION" ] ; then
27   return 0
28 else
29   return 1
30 fi
31 }
32 # avoid 'no matches found: ...'
33 iszsh && setopt no_nomatch # || echo "Warning: not running under zsh!"
34 # }}}
35
36 ### {{{ Utility Functions
37
38 # Simple shell grep
39 stringinfile(){
40   case "$(cat $2)" in *$1*) return 0;; esac
41   return 1
42 }
43
44 # same for strings
45 stringinstring(){
46   case "$2" in *$1*) return 0;; esac
47   return 1
48 }
49
50 # Reread boot command line; echo last parameter's argument or return false.
51 getbootparam(){
52   stringinstring " $1=" "$CMDLINE" || return 1
53   result="${CMDLINE##*$1=}"
54   result="${result%%[   ]*}"
55   echo "$result"
56   return 0
57 }
58
59 # Check boot commandline for specified option
60 checkbootparam(){
61   stringinstring " $1" "$CMDLINE"
62   return "$?"
63 }
64
65 checkvalue(){
66   if [ "$1" = "yes" ] ; then
67     return 0
68   else
69     return 1
70   fi
71 }
72
73 checkgrmlsmall(){
74   grep -q small /etc/grml_version 2>>$DEBUG && return 0 || return 1
75 }
76
77 checkgrmlusb(){
78   grep -q usb /etc/grml_version 2>>$DEBUG && return 0 || return 1
79 }
80 ### }}}
81
82 # {{{ filesystems (proc, pts, sys) and fixes
83 mount_proc(){
84   [ -f /proc/version ] || mount -t proc /proc /proc 2>/dev/null
85 }
86
87 mount_pts(){
88   stringinfile "/dev/pts" /proc/mounts || mount -t devpts /dev/pts /dev/pts 2>/dev/null
89 }
90
91 mount_sys(){
92   [ -d /sys/devices ] || mount -t sysfs /sys /sys 2>/dev/null
93 }
94 # }}}
95
96 # {{{ Read in boot parameters
97 [ -f /proc/version ] || mount_proc # make sure we can access /proc/cmdline when sourcing this file too
98 CMDLINE="$(cat /proc/cmdline)"
99 [ -d "${LIVECD_PATH}"/bootparams/ ] && CMDLINE="$CMDLINE $(cat ${LIVECD_PATH}/bootparams/* | tr '\n' ' ')"
100 # }}}
101
102 # {{{ Check if we are running from the grml-CD or HD
103 INSTALLED=""
104 [ -e /etc/grml_cd ] || INSTALLED="yes"
105
106 # testcd
107 TESTCD=""
108 checkbootparam "testcd" >>$DEBUG 2>&1 && TESTCD="yes"
109 # }}}
110
111 # {{{ source lsb-functions , color handling
112 if checkbootparam "nocolor"; then
113   RC_NOCOLOR=yes
114   . /etc/grml/lsb-functions
115   einfo "Disabling colors in bootsequence as requested on commandline." ; eend 0
116 else
117   . /etc/grml/lsb-functions
118   . /etc/grml_colors
119 fi
120 # }}}
121
122 # {{{ debug
123 config_debug(){
124  checkbootparam "debug"                        && BOOTDEBUG="yes"
125  stringinstring "BOOT_IMAGE=debug " "$CMDLINE" && BOOTDEBUG="yes"
126
127  rundebugshell(){
128   if [ -n "$BOOTDEBUG" ]; then
129      einfo "Starting intermediate shell stage $stage as requested by \"debug\" option."
130      if [ grep -q "debug=noscreen" "$CMDLINE" ] ; then
131         einfo "Notice that the shell does not provide job handling: ctrl-z, bg and fg won't work!"
132         einfo "Just exit the shell to continue boot process..."
133         /bin/zsh
134      else
135         eindent
136         if [ -r /etc/grml/screenrc ] ; then
137            einfo "Starting GNU screen to be able to use a full featured shell environment."
138            einfo "Just exit the shells (and therefore screen) to continue boot process..."
139            /bin/zsh -c "screen -c /etc/grml/screenrc"
140         else
141            einfo "Notice that the shell does not provide job handling: ctrl-z, bg and fg won't work!"
142            einfo "Just exit the shell to continue boot process..."
143            /bin/zsh
144         fi
145         eoutdent
146      fi
147   fi
148  }
149 }
150 # }}}
151
152 # {{{ log
153 config_log(){
154 if checkbootparam "log" || checkbootparam "debug" ; then
155    export DEBUG="/tmp/grml.log.`date +%Y%m%d`"
156    touch $DEBUG
157    einfo "Bootparameter log found. Log files: ${DEBUG} and /var/log/boot"
158    eindent
159      einfo "Starting bootlogd." # known to be *very* unreliable :(
160      bootlogd -r -c 1>>$DEBUG 2>&1 ; eend $?
161    eoutdent
162 else
163    DEBUG="/dev/null"
164 fi
165 }
166 # }}}
167
168 # {{{ set firmware timeout via bootparam
169 config_fwtimeout(){
170  if checkbootparam fwtimeout ; then
171    TIMEOUT="$(getbootparam 'fwtimeout' 2>>$DEBUG)"
172    einfo "Bootoption fwtimeout found. (Re)Loading firmware_class module."
173    rmmod firmware_class 1>>$DEBUG 2>&1
174    modprobe firmware_class ; eend $?
175  fi
176  if [ -z "$TIMEOUT" ] ; then
177    TIMEOUT="100" # linux kernel default: 10
178  fi
179  if [ -f /sys/class/firmware/timeout ] ; then
180    einfo "Setting timeout for firmware loading to ${TIMEOUT}."
181    echo 100 > /sys/class/firmware/timeout ; eend $?
182  fi
183 }
184 # }}}
185
186 ### {{{ language configuration / localization
187 config_language(){
188
189  einfo "Activating language settings:"
190  eindent
191
192  # people can specify $LANGUAGE and $CONSOLEFONT in a config file:
193  [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
194
195  grep -q ' lang=.*-utf8' /proc/cmdline && UTF8='yes' || UTF8=''
196
197  # check for bootoption which overrides config from /etc/grml/autoconfig:
198  BOOT_LANGUAGE="$(getbootparam lang 2>>$DEBUG)"
199  [ -n "$BOOT_LANGUAGE" ] && LANGUAGE="$BOOT_LANGUAGE"
200
201  # set default to 'en' in live-cd mode if $LANGUAGE is not yet set:
202  if [ -z "$INSTALLED" ] ; then
203     [ -n "$LANGUAGE" ] || LANGUAGE='en-utf8'
204  fi
205
206  # if bootoption lang is used update /etc/default/locale, otherwise *not*!
207  if [ -n "$BOOT_LANGUAGE" ] ; then
208     [ -x /usr/sbin/grml-setlang ] && /usr/sbin/grml-setlang "$LANGUAGE"
209  fi
210
211  # set console font
212  if [ -z "$CONSOLEFONT" ] ; then
213     if ! checkbootparam "nodefaultfont" >>$DEBUG 2>&1 ; then
214        # [ -n "$UTF8" ] && CONSOLEFONT='LatArCyrHeb-16' || CONSOLEFONT='Lat15-Terminus16'
215        # if [ -r /usr/share/consolefonts/Lat15-Terminus16.psf.gz ] ; then
216        if [ -r /usr/share/consolefonts/Uni3-Terminus16.psf.gz ] ; then
217           CONSOLEFONT='Uni3-Terminus16'
218        else
219           ewarn "/usr/share/consolefonts/Uni3-Terminus16.psf.gz not available. Please upgrade package console-terminus." ; eend 1
220        fi
221     fi
222  fi
223
224  # export it now, so error messages get translated, too
225  if checkgrmlsmall ; then
226     export LANG='C' # grml-small does not provide any further locales
227  else
228     [ -r /etc/default/locale ] && . /etc/default/locale
229     export LANG LANGUAGE
230  fi
231
232  # configure keyboard layout, read in already set values first:
233  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
234
235  # now allow keyboard override by boot commandline for later use:
236  KKEYBOARD="$(getbootparam keyboard 2>>$DEBUG)"
237  [ -n "$KKEYBOARD" ] && KEYTABLE="$KKEYBOARD"
238  # notce: de/at is a bad choice, so take de-latin1-nodeadkeys instead:
239  [[ "$KKEYBOARD" == 'de' ]] && KEYTABLE=de-latin1-nodeadkeys
240  [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
241
242  # modify /etc/sysconfig/keyboard only in live-cd mode:
243  if [ -z "$INSTALLED" ] ; then
244
245    local LANGUAGE="$BOOT_LANGUAGE"
246    . /etc/grml/language-functions
247    # allow setting xkeyboard explicitly different than console keyboard
248    KXKEYBOARD="$(getbootparam xkeyboard 2>>$DEBUG)"
249    if [ -n "$KXKEYBOARD" ]; then
250       XKEYBOARD="$KXKEYBOARD"
251       KDEKEYBOARD="$KXKEYBOARD"
252    elif [ -n "$KKEYBOARD" ]; then
253       XKEYBOARD="$KKEYBOARD"
254       KDEKEYBOARD="$KKEYBOARD"
255    fi
256
257    # duplicate of previous code to make sure /etc/grml/language-functions
258    # does not overwrite our values....
259    # now allow keyboard override by boot commandline for later use:
260    KKEYBOARD="$(getbootparam keyboard 2>>$DEBUG)"
261    [ -n "$KKEYBOARD" ] && KEYTABLE="$KKEYBOARD"
262    # notce: de/at is a bad choice, so take de-latin1-nodeadkeys instead:
263    [[ "$KKEYBOARD" == 'de' ]] && KEYTABLE=de-latin1-nodeadkeys
264    [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
265
266    # write keyboard related variables to file for later use
267    [ -d /etc/sysconfig ] || mkdir /etc/sysconfig
268    if ! [ -e /etc/sysconfig/keyboard ] ; then
269       echo "KEYTABLE=\"$KEYTABLE\""          > /etc/sysconfig/keyboard
270       echo "XKEYBOARD=\"$XKEYBOARD\""       >> /etc/sysconfig/keyboard
271       echo "KDEKEYBOARD=\"$KDEKEYBOARD\""   >> /etc/sysconfig/keyboard
272       echo "KDEKEYBOARDS=\"$KDEKEYBOARDS\"" >> /etc/sysconfig/keyboard
273    fi
274  fi
275
276  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
277
278  # activate unicode console if running within utf8 environment
279  if [ -r /etc/default/locale ] ; then
280     if grep -q "LANG=.*UTF" /etc/default/locale ; then
281        einfo "Setting up unicode environment."
282        unicode_start 2>>$DEBUG ; eend $?
283     fi
284  fi
285
286  # Set default keyboard before interactive setup
287  if [ -n "$KEYTABLE" ] ; then
288     einfo "Running loadkeys for ${WHITE}${KEYTABLE}${NORMAL} in background"
289     loadkeys -q $KEYTABLE &
290     eend $?
291  fi
292
293  # we have to set up all consoles, therefore loop it over all ttys:
294  NUM_CONSOLES=$(fgconsole --next-available)
295  NUM_CONSOLES=$(expr ${NUM_CONSOLES} - 1)
296  [ ${NUM_CONSOLES} -eq 1 ] && NUM_CONSOLES=6
297  CUR_CONSOLE=$(fgconsole)
298
299  if [ -n "$CHARMAP" ] ; then
300     einfo "Running consolechars for ${CHARMAP}"
301     for vc in `seq 0 ${NUM_CONSOLES}`  ; do
302         consolechars --tty=/dev/tty${vc} -m ${CHARMAP} ; RC=$?
303     done
304     [ -n "$CUR_CONSOLE" ] && chvt $CUR_CONSOLE
305     eend $RC
306  fi
307
308  if checkbootparam noconsolefont ; then
309     ewarn "Skipping setting console font as requested on boot commandline." ; eend 0
310  else
311     if [ -n "$CONSOLEFONT" ] ; then
312        einfo "Running consolechars using ${CONSOLEFONT}"
313        for vc in `seq 0 ${NUM_CONSOLES}`  ; do
314            consolechars --tty=/dev/tty${vc} -f $CONSOLEFONT ; RC=$?
315        done
316        [ -n "$CUR_CONSOLE" ] && chvt $CUR_CONSOLE
317        eend $?
318     fi
319  fi
320
321  eoutdent
322 }
323 # }}}
324
325 # {{{ Set hostname
326 config_hostname(){
327  if checkbootparam hostname ; then
328   HOSTNAME="$(getbootparam 'hostname' 2>>$DEBUG)"
329   einfo "Setting hostname to $HOSTNAME as requested."
330   sed -i "s/^127.0.0.1.*localhost/127.0.0.1 $HOSTNAME localhost/" /etc/hosts
331   hostname $HOSTNAME ; eend $?
332  else
333   hostname --file /etc/hostname
334  fi
335 }
336 # }}}
337
338 # fstabuser (needed when running from harddisk with username != grml {{{
339 config_userfstab(){
340   [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
341   if [ -n "$CONFIG_FSTAB_USER" ] ; then
342      fstabuser="$CONFIG_FSTAB_USER"
343   else
344      fstabuser=$(getent passwd 1000 | cut -d: -f1)
345   fi
346   # if not yet set fall back to default 'grml' user
347   [ -n "$fstabuser" ] || fstabuser='grml'
348 }
349 # }}}
350
351 # {{{ Set clock (Local time is more often used than GMT, so it is default)
352 config_time(){
353  # don't touch the files if running from harddisk:
354  if [ -z "$INSTALLED" ]; then
355     UTC=""
356     checkbootparam utc >>$DEBUG 2>&1 && UTC="-u"
357     checkbootparam gmt >>$DEBUG 2>&1 && UTC="-u"
358     # hwclock uses the TZ variable
359     [ -r /etc/timezone ] && TZ=$(cat /etc/timezone)
360     [ -n "$TZ" ] || TZ=Europe/Vienna
361
362     if ! [ -r /dev/rtc ] ; then
363       ewarn "Realtime clock not available, skipping execution of hwclock therefore." ; eend 0
364     else
365       ERROR=$(TZ="$TZ" hwclock $UTC -s 2>&1 | head -1) ; RC=$?
366       if [ -n "$ERROR" ] ; then
367          eindent
368          ERROR=$(TZ="$TZ" hwclock $UTC -s --directisa 2>&1 | head -1)
369          if [ -n "$ERROR" ] ; then
370             eerror "Problem running hwclock: $ERROR" ; eend 1
371          fi
372          eoutdent
373       fi
374     fi
375  fi
376 }
377 # }}}
378
379 # {{{ print kernel info
380 config_kernel(){
381   vmware-detect &>/dev/null && VMWARE="inside ${WHITE}VMware/Qemu${NORMAL}"
382   [ -d /proc/xen ] && VMWARE='' # vmware-detect returns '0' when running with a Xen-enabled kernel
383   einfo "Running Linux Kernel $KERNEL $VMWARE" ; eend 0
384   if [ -r /proc/cpuinfo ] ; then
385      if egrep -q '^flags.*(vmx|svm)' /proc/cpuinfo ; then
386        eindent
387        einfo 'CPU(s) featuring virtualization technology detected' ; eend 0
388        eoutdent
389      fi
390   fi
391   if [ -d /proc/xen ] ; then
392      eindent
393      einfo 'Running kernel featuring support for Xen detected' ; eend 0
394      eoutdent
395   fi
396 }
397 # }}}
398
399 # {{{ vmware specific stuff
400 config_vmware(){
401 if checkbootparam novmware ; then
402    ewarn "Skipping running vmware specific stuff as requested on boot commandline." ; eend 0
403 else
404    if [ -z "$INSTALLED" ] ; then
405       if vmware-detect || stringinstring "BOOT_IMAGE=vmware " "$CMDLINE" ; then
406          if ! checkbootparam qemu ; then
407             if [ -r /etc/X11/xorg.conf.vmware ] ; then
408                einfo "VMware: Copying /etc/X11/xorg.conf.vmware to /etc/X11/xorg.conf"
409                cp /etc/X11/xorg.conf.vmware /etc/X11/xorg.conf ; eend $?
410             fi
411          fi
412       elif [ -r /proc/acpi/battery/BAT0/info -a -r /etc/X11/xorg.conf.virtualbox ] ; then
413          if grep -q 'OEM info:                innotek' /proc/acpi/battery/BAT0/info ; then
414             einfo 'Virtual Box: Copying /etc/X11/xorg.conf.virtualbox to /etc/X11/xorg.conf'
415             cp /etc/X11/xorg.conf.virtualbox /etc/X11/xorg.conf ; eend $?
416          fi
417       fi
418    fi
419 fi
420 }
421 # }}}
422
423 # {{{ qemu specific stuff
424 config_qemu(){
425 if checkbootparam qemu ; then
426    if [ -r /etc/X11/xorg.conf.example ] ; then
427       einfo "Qemu: Copying /etc/X11/xorg.conf.example to /etc/X11/xorg.conf"
428       cp /etc/X11/xorg.conf.example /etc/X11/xorg.conf ; eend $?
429    fi
430 fi
431 }
432 # }}}
433
434 # {{{ ld.so.cache + depmod
435 config_ld_mod(){
436 if [ -n "$INSTALLED" ]; then
437  if ! [ -r /etc/grml.first.boot ] ; then
438   einfo "Running from HD for the first time, regenerate ld.so.cache and modules.dep:"
439   eindent
440 # Regenerate ld.so.cache and module dependencies on HD
441     einfo "Running ldconfig" ; ldconfig  ; eend $?
442     einfo "Running depmod"   ; depmod -a ; eend $?
443     touch /etc/grml.first.boot
444     eend 0
445   eoutdent
446  fi
447 fi
448 }
449 # }}}
450
451 # {{{ timezone
452 config_timezone(){
453  # don't touch the files if running from harddisk:
454  if [ -z "$INSTALLED" ]; then
455     KTZ="$(getbootparam tz 2>>$DEBUG)"
456     if [ -n "$KTZ" ] ; then
457        einfo "Setting timezone."
458        [ -f "/usr/share/zoneinfo/$KTZ" ] && TZ="$KTZ"
459        rm -f /etc/localtime
460        cp "/usr/share/zoneinfo/$TZ" /etc/localtime ; eend $?
461     fi
462  fi
463 }
464 # }}}
465
466 # small computer / nearly no ram {{{
467 config_small(){
468
469 RAM=$(/usr/bin/gawk '/MemTotal/{print $2}' /proc/meminfo)
470 # MEM=$(/usr/bin/gawk 'BEGIN{m=0};/MemFree|Cached|SwapFree/{m+=$2};END{print m}' /proc/meminfo)
471 eindent
472
473 if checkbootparam "small"; then
474   einfo "Information: ${RAM} kB of RAM available." ; eend 0
475   einfo "Bootoption small detected. Activating small system."
476   if [ -r /etc/inittab.small ] ; then
477     mv /etc/inittab /etc/inittab.normal
478     mv /etc/inittab.small /etc/inittab
479   else
480     sed -i 's/^9/#&/' /etc/inittab
481     sed -i 's/^10/#&/' /etc/inittab
482     sed -i 's/^11/#&/' /etc/inittab
483     sed -i 's/^12/#&/' /etc/inittab
484   fi
485   /sbin/telinit q ; eend $?
486 else
487   if checkgrmlsmall ; then
488     if [[ $RAM -lt 25000 ]] ; then
489       ewarn "Information: ${RAM} kB of RAM available." ; eend 1
490       ewarn "At least 32MB of RAM should be available for grml-small." ; eend 1
491       ewarn "Use the bootoption small to save some more MB of memory usage." ; eend 0
492       ewarn "Dropping you into a rescue shell. To continue booting exit the shell." ; eend 0
493       /bin/zsh --login
494     else
495       einfo "Information: ${RAM} kB of RAM available." ; eend 0
496     fi
497   else
498     if [[ $RAM -lt 58000 ]] ; then
499       ewarn "Information: ${RAM} kB of RAM available." ; eend 1
500       ewarn "At least 64MB of RAM should be available for grml." ; eend 1
501       ewarn "Use the bootoption small to save some more MB of memory usage." ; eend 0
502       ewarn "Dropping you into a rescue shell. To continue booting exit the shell." ; eend 0
503       /bin/zsh --login
504     else
505       einfo "Information: ${RAM} kB of RAM available." ; eend 0
506     fi
507   fi
508 fi
509 eoutdent
510 }
511 # }}}
512
513 # skip startup of w3m {{{
514 config_fast(){
515 if checkbootparam "fast"; then
516   ewarn "Bootoption fast detected. Skipping startup of w3m."
517     sed -i 's#^1:.*#1:12345:respawn:/usr/bin/openvt -f -c 1 -w -- /bin/zsh#' /etc/inittab
518   /sbin/telinit q ; eend $?
519 fi
520 }
521 # }}}
522
523 # activate serial console {{{
524 config_console(){
525 if checkbootparam "console"; then
526   einfo "Bootoption (for serial) console detected."
527   eindent
528     if [ -r /etc/mgetty/mgetty.config ] ; then
529        MODE=$(getbootparam console | awk -F, '{print $2}')
530        MODE=${MODE%%n*}
531        [ -n "$MODE" ] || MODE=9600 # default mode
532        einfo "Setting speed in /etc/mgetty/mgetty.config to $MODE bps"
533        sed -i "s/speed [0-9]*/speed $MODE/" /etc/mgetty/mgetty.config ; eend $?
534     fi
535
536     einfo "Activating mgetty."
537     sed -i 's/^#T0/T0/' /etc/inittab
538     sed -i 's/^#T1/T1/' /etc/inittab
539     /sbin/telinit q ; eend $?
540   eoutdent
541 fi
542 }
543 # }}}
544
545 # For burning on IDE-CD-Roms, k3b (and others) check for special permissions {{{
546 config_cdrom_perm(){
547 CDROMS=""
548 for DEVICE in /proc/ide/hd?; do
549  [ "$(cat $DEVICE/media 2>/dev/null)" = "cdrom" ] && CDROMS="$CDROMS /dev/${DEVICE##*/}"
550 done
551 [ -n "$CDROMS" ] && { chown root.cdrom $CDROMS; chmod 666 $CDROMS; } 2>/dev/null
552 }
553 # }}}
554
555 # {{{ Bring up loopback interface now
556 config_local_net(){
557  if [ -z "$INSTALLED" ] ; then
558     if grep -q 'iface lo inet loopback' /etc/network/interfaces 2>/dev/null ; then
559        grep -q lo=lo /etc/network/run/ifstate 2>/dev/null || ifup lo
560     else
561        ifconfig lo up
562     fi
563  fi
564 }
565 # }}}
566
567 # firewire devices {{{
568 # the raw1394 driver does not yet export info into SYSFS,
569 # so let's create raw1394 device manually
570 # http://www.michael-prokop.at/blog/index.php?p=352
571 config_firewire_dev(){
572 if checkbootparam "nofirewiredev" ; then
573   ewarn "Skipping creating some firewire devices as requested on boot commandline." ; eend 0
574 else
575 #if [ "${KERNEL%-*}" == "2.6.11" ] ; then
576   einfo "Creating some firewire devices (fix kernel 2.6-bug)."
577 #  cd /dev && MAKEDEV video1394 raw1394
578   [ -r /dev/raw1394 ]   || mknod /dev/raw1394 c 171 0
579   [ -r /dev/video1394 ] || mknod -m 666 /dev/video1394 c 171 16
580 # mknod -m 666 /dev/dv1394 c 171 32 # for NTSC
581   [ -r /dev/dv1394 ]    || mknod -m 666 /dev/dv1394 c 171 34 # for PAL
582   chown -R root:video /dev/raw1394 /dev/video1394 /dev/dv1394
583   chmod -R 664 /dev/raw1394 /dev/video1394 /dev/dv1394 ; eend $?
584 fi
585 #fi
586 }
587 # }}}
588
589 # {{{ copy passwd-lockfile to ramdisk (fix unionfs-behaviour)
590 # otherwise we will get: passwd: Authentication token lock busy
591 config_fix_passwd(){
592  if [ -z "$INSTALLED" ] ; then
593   touch /etc/.pwd.lock
594  fi
595 }
596 # }}}
597
598 # {{{ CD Checker
599 config_testcd(){
600 if [ -n "$TESTCD" ]; then
601    einfo "Checking CD data integrity as requested by '${WHITE}testcd${NORMAL}' boot option."
602    einfo "Reading files and checking against GRML/md5sums, this may take a while..."
603    echo -n "${RED}"
604
605    if [ -n "${LIVECD_PATH}"/GRML ] ; then
606       ( cd "${LIVECD_PATH}"/GRML ; rm -f /tmp/md5sum.log ; md5sum -c md5sums 2>&1 | tee /tmp/md5sum.log ; RC=$? )
607    else
608       echo "${RED} *** Error: Could not find md5sum file.                           ***"
609    fi
610
611    if [ "$RC" = "0" ]; then
612       einfo "Everything looks OK" ; eend 0
613    else
614       eerror 'Checksum failed for theses files:' ; eend 1
615       egrep -v '(^md5sum:|OK$)' /tmp/md5sum.log
616       eerror 'Data on the grml medium is possibly incomplete/damaged or...'
617       eerror '... RAM of your computer is broken.' ; eend 1
618       einfon "Hit return to continue, or press the reset button to quit."
619      read a
620    fi
621
622    eend 0
623 fi
624 }
625 # }}}
626
627 # {{{ hardware detection via discover
628 config_discover(){
629 if checkbootparam "nodisc" ; then
630   ewarn "Skipping hardware detection via discover as requested on boot commandline." ; eend 0
631 else
632  if [ -x /sbin/discover ] ; then
633   einfo "Discovering hardware. Trying to load the following modules in background:"
634    eindent
635    einfo "$(discover --data-path=linux/module/name --data-path=linux/modules/options --format="%s %s" --data-version=`uname -r` --enable-bus all | sort -u | xargs echo)"
636    eoutdent
637   /sbin/discover-modprobe -v 1>>$DEBUG 2>&1 &
638   eend 0
639  else
640   eerror "Application discover not available. Information: udev should handle hardware recognition." ; eend 0
641  fi
642 fi
643 }
644 # }}}
645
646 # {{{ hardware detection via hwinfo
647 config_hwinfo(){
648 if checkbootparam hwinfo >>$DEBUG 2>&1; then
649   einfo "Discovering hardware via hwinfo:"
650   MODULES=$(su grml hwinfo | grep "Cmd: \"modprobe" | awk '{print $5}' | sed 's/"//')
651   echo -n "  Loading modules: "
652   for i in `echo $MODULES` ; do echo -n $i && modprobe $i ; done
653   eend 0
654 fi
655 }
656 # }}}
657
658 # {{{ disable hotplug agents on request
659 config_hotplug_agent(){
660 if checkbootparam "noagent" ; then
661   AGENT="$(getbootparam 'noagent' 2>>$DEBUG)"
662   AGENTLIST=$(echo "$AGENT" | sed 's/,/\\n/g')
663   AGENTNL=$(echo "$AGENT" | sed 's/,/ /g')
664   einfo "Disabling hotplug-agent(s) $AGENTNL"
665   for agent in $(echo -e $AGENTLIST) ; do
666     mv /etc/hotplug/${agent}.rc /etc/hotplug/${agent}.norc
667   done
668   [ "$?" == "0" ] ; eend $?
669 fi
670 }
671 # }}}
672
673 # {{{ blacklist of hotplug-modules
674 config_hotplug_blacklist(){
675 if checkbootparam "black" ; then
676   BLACK="$(getbootparam 'black' 2>>$DEBUG)"
677   BLACKLIST=$(echo "$BLACK" | sed 's/,/\\n/g')
678   BLACKNL=$(echo "$BLACK" | sed 's/,/ /g')
679   einfo "Blacklisting $BLACKNL via /etc/hotplug/blacklist.d/hotplug-light"
680   echo -e "$BLACKLIST" >> /etc/hotplug/blacklist.d/hotplug-light
681   echo -e "$BLACKLIST" >> /etc/hotplug/blacklist
682   eend 0
683 fi
684 }
685 # }}}
686
687 # {{{ run hotplug
688 config_hotplug(){
689 if checkbootparam "nohotplug" ; then
690   ewarn "Skipping running hotplug as requested on boot commandline." ; eend 0
691 else
692   if [ -r /etc/init.d/hotplug ] ; then
693     einfo "Starting hotplug system in background."
694     /etc/init.d/hotplug start 1>>$DEBUG 2>>$DEBUG &
695     eend 0
696   elif [ -r /etc/init.d/hotplug-light ] ; then
697     einfo "Starting hotplug-light system in background."
698     /etc/init.d/hotplug-light start 1>>$DEBUG 2>>$DEBUG &
699     eend 0
700   else
701     ewarn "No hotplug system found. Should be handled by udev. Skipping execution." ; eend 0
702   fi
703 fi
704 }
705 # }}}
706
707 # {{{ blacklist specific module [ used in /etc/init.d/udev ]
708 config_blacklist(){
709 if checkbootparam "blacklist" ; then
710  if [ -z "$INSTALLED" ]; then
711   einfo "Bootoption blacklist found."
712   BLACK="$(getbootparam 'blacklist' 2>>$DEBUG)"
713   if [ -n "$BLACK" ] ; then
714     for module in $(echo ${BLACK//,/ }) ; do
715         einfo "Blacklisting module ${module} via /etc/modprobe.d/grml."
716         echo "# begin entry generated by config_blacklist of grml-autoconfig" >> /etc/modprobe.d/grml
717         echo "blacklist $module"     >> /etc/modprobe.d/grml
718         echo "alias     $module off" >> /etc/modprobe.d/grml
719         echo "# end   entry generated by config_blacklist of grml-autoconfig" >> /etc/modprobe.d/grml ; eend $?
720     done
721   else
722    eerror "No given module for blacklist found. Blacklisting will not work therefore."
723   fi
724  else
725   ewarn "Backlisting via bootoption is not intended for use on harddisk installations." ; eend 1
726   eindent
727    einfo "Please blacklist the module(s) manually using the 'blacklist' script."
728   eoutdent
729  fi
730 fi
731 }
732 # }}}
733
734 # {{{ ACPI
735 config_acpi_apm(){
736 if [ -d /proc/acpi ]; then
737   if checkbootparam "noacpi"; then
738     ewarn "Skipping ACPI Bios detection as requested via noacpi on boot commandline." ; eend 0
739   elif checkbootparam "nogrmlacpi" ; then
740     ewarn "Skipping ACPI Bios detection as requested via nogrmlacpi on boot commandline." ; eend 0
741   else
742     einfo "ACPI Bios found, activating modules (disable via bootoption noacpi / nogrmlacpi): "
743     eindent
744     found=""
745     for a in /lib/modules/$KERNEL/kernel/drivers/acpi/*; do
746       basename="${a##*/}"
747       basename="${basename%%.*}"
748       case "$basename" in *_acpi)
749        egrep -qi "${basename%%_acpi}" /proc/acpi/dsdt 2>>$DEBUG || continue ;;
750       esac
751       modprobe $basename >>$DEBUG 2>&1 && found="yes"
752       local BASE="$BASE $basename"
753     done
754     if [ -n "$found" ] ; then
755       einfo "$BASE"  ; eend 0
756     else
757       ewarn "(none)" ; eend 1
758     fi
759     if ! ps x | grep -q /usr/sbin/acpid ; then
760       if ! [ -r /var/run/dbus/pid ] ; then
761         einfo "Starting acpi daemon."
762         /etc/init.d/acpid start 1>>$DEBUG 2>&1 ; eend $?
763       else
764         eerror "acpid error: it seems you are running d-bus/hal, but acpid needs to be started before d-bus."
765         eerror "Solution: please activate acpid via /etc/runlevel.conf"
766         eend 1
767       fi
768     else
769       ewarn "acpi daemon already running."
770       eend 0
771     fi
772     eoutdent
773   fi
774 else
775 # APM
776   if checkbootparam "noapm"; then
777     ewarn "Skipping APM Bios detection as requested on boot commandline." ; eend 0
778   else
779     modprobe apm power_off=1 >>$DEBUG 2>&1
780     if [ "$?" = "0" ] ; then
781        if [ -x /etc/init.d/apmd ] ;then
782           einfo "APM Bios found, enabling power management functions."
783           /etc/init.d/apmd start ; eend $?
784        fi
785     else
786       eerror "Loading apm module failed." ; eend 1
787     fi
788   fi
789 fi
790 }
791 # }}}
792
793 # {{{ PCMCIA Check/Setup
794 # This needs to be done before other modules are being loaded (by hwsetup)
795 config_pcmcia(){
796 if checkbootparam "nopcmcia"; then
797   ewarn "Skipping PCMCIA detection as requested on boot commandline." ; eend 0
798 else
799   if /usr/sbin/laptop-detect ; then
800     einfo "Detected Laptop - checking for PCMCIA." && eend 0
801     modprobe pcmcia_core >>$DEBUG 2>&1
802     # Try Cardbus or normal PCMCIA socket drivers
803     modprobe yenta_socket >>$DEBUG 2>&1 || modprobe i82365 >>$DEBUG 2>&1 || modprobe pd6729 >>$DEBUG 2>&1 || modprobe tcic >>$DEBUG 2>&1
804     if [ "$?" = "0" ]; then
805       modprobe ds >>$DEBUG 2>&1
806       if [ -d /proc/bus/pccard ] ; then
807        if [ -x /sbin/cardmgr ] ; then
808         einfo "PCMCIA found, starting cardmgr."
809         cardmgr >>$DEBUG 2>&1 && sleep 6 && eend 0
810        else
811         eerror "No cardmgr found. Make sure package pcmciautils is installed, it should handle it instead." ; eend 1
812        fi
813       fi
814     fi
815   fi
816 fi
817 }
818 # }}}
819
820 # {{{ run software synthesizer via speakup
821 config_swspeak(){
822 if checkbootparam swspeak ; then
823  if [ -d /proc/speakup/ ] ; then
824   einfo "Bootoption swspeak found. Kernel supports speakup." ; eend 0
825   eindent
826    if [ -x /etc/init.d/speech-dispatcher ] ; then
827      einfo "Starting speech-dispatcher."
828      /etc/init.d/speech-dispatcher start 1>>DEBUG ; eend $?
829      einfo "Activating sftsyn in Kernel."
830      echo sftsyn >/proc/speakup/synth_name ; eend $?
831      einfo "Just run swspeak if you want to use software synthesizer via speakup."
832      flite -o play -t "Finished activating software speakup. Just run swspeak when booting finished."
833    else
834     eerror "speech-dispatcher not available. swspeak will not work without it." ; eend 1
835     flite -o play -t "speech-dispatcher not available. speakup will not work without it."
836    fi
837   eoutdent
838  else
839   eerror "Kernel does not seem to support speakup. Skipping swspeak." ; eend 1
840   flite -o play -t "Kernel does not seem to support speakup. Sorry."
841  fi
842 fi
843 }
844 # }}}
845
846 # {{{ Check for blind option or brltty
847 config_blind(){
848 BLIND=""
849 checkbootparam "blind" && BLIND="yes"
850 BRLTTY="$(getbootparam brltty 2>>$DEBUG)"
851
852 if [ -n "$BLIND" -o -n "$BRLTTY" ]; then
853   if [ -x /sbin/brltty ]; then
854     # Blind option detected, start brltty now.
855     # modprobe serial_core parport_serial generic_serial && echo "done"
856     CMD=brltty
857     BRLTYPE=""
858     BRLDEV=""
859     BRLTEXT=""
860     if [ -n "$BRLTTY" ]; then
861       # Extra options
862       BRLTYPE="${BRLTTY%%,*}"
863       R="${BRLTTY#*,}"
864       if [ -n "$R" -a "$R" != "$BRLTTY" ]; then
865         BRLTTY="$R"
866         BRLDEV="${BRLTTY%%,*}"
867         R="${BRLTTY#*,}"
868         if [ -n "$R" -a "$R" != "$BRLTTY" ]; then
869           BRLTTY="$R"
870           BRLTEXT="${BRLTTY%%,*}"
871           R="${BRLTTY#*,}"
872         fi
873       fi
874     fi
875     [ -n "$BRLTYPE" ] && CMD="$CMD -b $BRLTYPE"
876     [ -n "$BRLDEV"  ] && CMD="$CMD -d $BRLDEV"
877     [ -n "$BRLTEXT" ] && CMD="$CMD -t $BRLTEXT"
878     einfo "Starting braille-display manager."
879 #    ( exec $CMD & )
880     ( sh -c "$CMD" & )
881     sleep 2 && BLINDSOUND="yes"
882     eend 0
883   fi
884 fi
885 }
886 # }}}
887
888 # {{{ Interactive configuration
889 config_interactive(){
890   ewarn "config_interactive is deprecated nowadays."
891   ewarn "Please set CONFIG_INTERACTIVE='no' in /etc/grml/autoconfig" ; eend 0
892 }
893 # }}}
894
895 # {{{ AGP
896 config_agp(){
897 if checkbootparam forceagp ; then
898 # Probe for AGP. Hope this can fail safely
899   stringinfile "AGP" "/proc/pci" 2>>$DEBUG && { modprobe agpgart || modprobe agpgart agp_try_unsupported=1; } >>$DEBUG 2>&1 && einfo "AGP bridge detected." ; eend 0
900 fi
901 }
902 # }}}
903
904 # {{{ automount(er)
905 config_automounter(){
906 if checkbootparam automounter ; then
907   RUNLEVEL="$(runlevel)"
908   AUTOMOUNTER=""
909   [ -x /etc/init.d/autofs ] && [ "$RUNLEVEL" != "N 1" ] && [ "$RUNLEVEL" != "N S" ] && AUTOMOUNTER="yes"
910
911 addautomount(){
912 # /dev/ice  options
913   d="${1##*/}"
914   if [ -n "$AUTOMOUNTER" ]; then
915     [ -d "/mnt/$d" -a ! -L "/mnt/$d" ] && rmdir /mnt/$d
916     [ -d "/mnt/auto/$d" ] || mkdir -p "/mnt/auto/$d"
917     [ -L "/mnt/$d" ]      || ln -s "/mnt/auto/$d" "/mnt/$d"
918     anew="$d        -fstype=auto,$2 :$i"
919     stringinfile "$anew" "/etc/auto.mnt" || echo "$anew" >> /etc/auto.mnt
920     AUTOMOUNTS="$AUTOMOUNTS $d"
921     new="$1 /mnt/auto/$d  auto   users,noauto,exec,$2 0 0"
922   else
923     [ -d /mnt/$d ] && mkdir -p /mnt/$d
924     new="$1 /mnt/$d  auto   users,noauto,exec,$2 0 0"
925   fi
926   stringinfile "$new" "/etc/fstab" || echo "$new" >> /etc/fstab
927 }
928
929   AUTOMOUNTS="floppy cdrom"
930 # Add new devices to /etc/fstab and /etc/auto.mnt
931   for i in /dev/cdrom?*; do
932     if [ -L $i ]; then
933       addautomount "$i" "ro"
934     fi
935   done
936 fi
937
938 if [ -n "$AUTOMOUNTER" ]; then
939 # Check for floppy dir, reinstall with automounter
940   [ -d /mnt/floppy -a ! -L /mnt/floppy ] && rmdir /mnt/floppy
941   [ -d /mnt/auto/floppy ] || mkdir -p /mnt/auto/floppy
942   [ -L /mnt/floppy ] || ln -s /mnt/auto/floppy /mnt/floppy
943   [ -d /mnt/cdrom -a ! -L /mnt/cdrom ] && rmdir /mnt/cdrom
944   [ -d /mnt/auto/cdrom ] || mkdir -p /mnt/auto/cdrom
945   [ -L /mnt/cdrom ] || ln -s /mnt/auto/cdrom /mnt/cdrom
946   rm -f /etc/fstab.new
947 # Replace paths from bootfloppy
948   sed 's|/mnt/cdrom|/mnt/auto/cdrom|g;s|/mnt/floppy|/mnt/auto/floppy|g' /etc/fstab > /etc/fstab.new
949   mv -f /etc/fstab.new /etc/fstab
950 # Start automounter now
951   einfo "Starting automounter for ${AUTOMOUNTS}."
952   /etc/init.d/autofs start >>$DEBUG ; eend $?
953 fi
954 }
955 # }}}
956
957 # {{{ Collect partitions from /proc/partitions first for enabling DMA
958 check_partitions(){
959 partitions=""
960 IDEDISKS=""
961 while read major minor blocks partition relax; do
962   partition="${partition##*/}"
963   [ -z "$partition" -o ! -e "/dev/$partition" ] && continue
964   case "$partition" in
965     hd?) IDEDISKS="$IDEDISKS $partition";;                # IDE  Harddisk, entire disk
966     sd?) ;;                                               # SCSI Harddisk, entire disk
967 #    [hs]d*) partitions="$partitions /dev/$partition";;    # IDE or SCSI disk partition
968     [hs]d*|ub*) partitions="$partitions /dev/$partition";;    # IDE, USB or SCSI disk partition
969   esac
970 done <<EOT
971 $(awk 'BEGIN{old="__start"}{if($0==old){exit}else{old=$0;if($4&&$4!="name"){print $0}}}' /proc/partitions)
972 EOT
973 }
974 check_partitions 1>/dev/null 2>&1 # avoid output "check_partitions:3: read-only file system"
975 # }}}
976
977 # {{{ Enable DMA for all IDE drives now if not disabled
978 # Notice: Already done by linuxrc, but make sure it's done also on harddisk-installed systems
979 config_dma(){
980 if checkbootparam "nodma"; then
981   ewarn "Skipping DMA accelleration as requested on boot commandline." ; eend 0
982 else
983   for d in $(cd /proc/ide 2>>$DEBUG && echo hd[a-z]); do
984     if test -d /proc/ide/$d; then
985       if egrep -q 'using_dma[ \t]+0' /proc/ide/$d/settings 2>>$DEBUG; then
986         MODEL="$(cat /proc/ide/$d/model 2>>$DEBUG)"
987         test -z "$MODEL" && MODEL="[GENERIC IDE DEVICE]"
988         einfo "Enabling DMA acceleration for: ${WHITE}$d        ${YELLOW}[${MODEL}]${NORMAL}"
989         echo "using_dma:1" >/proc/ide/$d/settings
990         eend 0
991       fi
992     fi
993   done
994 fi
995 }
996 # }}}
997
998 # {{{ Start creating /etc/fstab with HD partitions and USB SCSI devices now
999 config_fstab(){
1000
1001 NOSWAP="yes" # we do not use swap by default!
1002 if checkbootparam "swap" || checkbootparam "anyswap" ; then
1003    NOSWAP=''
1004    checkbootparam "anyswap" && export ANYSWAP='yes' || export ANYSWAP=""
1005 fi
1006
1007 if checkbootparam "nofstab" || checkbootparam "forensic" ; then
1008   ewarn "Skipping /etc/fstab creation as requested on boot commandline." ; eend 0
1009 else
1010   einfo "Scanning for harddisk partitions and creating /etc/fstab. (Disable this via boot option: nofstab)"
1011   iszsh && setopt nonomatch
1012   if [ -x /usr/sbin/rebuildfstab ] ; then
1013      config_userfstab || fstabuser=grml
1014      /usr/sbin/rebuildfstab -r -u $fstabuser -g $fstabuser ; eend $?
1015   else
1016      ewarn "Command rebuildfstab not found. Install package grml-rebuildfstab." ; eend 1
1017   fi
1018 fi # checkbootparam nofstab/forensic
1019
1020 # Scan for swap, config, homedir - but only in live-mode
1021 if [ -z "$INSTALLED" ] ; then
1022    [ -z "$NOSWAP" ] && einfo "Searching for swap partition(s) as requested."
1023    GRML_IMG=""
1024    GRML_SWP=""
1025    HOMEDIR="$(getbootparam home)"
1026    if [ -n "$partitions" ]; then
1027       while read p m f relax; do
1028         case "$p" in *fd0*|*proc*|*sys*|*\#*) continue;; esac
1029         partoptions="users,exec"
1030         fnew=""
1031         # it's a swap partition?
1032         case "$f" in swap)
1033           eindent
1034           if [ -n "$NOSWAP" ]; then
1035              ewarn "Ignoring swap partition ${WHITE}$p${NORMAL}. (Force usage via boot option 'swap', or execute grml-swapon)"
1036              eend 0
1037           else
1038              case "$(dd if=$p bs=1 count=6 skip=4086 2>/dev/null)" in
1039                    S1SUSP|S2SUSP|pmdisk|[zZ]*)
1040                      if [ -n "$ANYSWAP" ] ; then
1041                         einfo "Using swap partition ${WHITE}${p}${NORMAL} [bootoption anyswap found]."
1042                         swapon $p 2>>$DEBUG ; eend $?
1043                      else
1044                         ewarn "Suspend signature on ${WHITE}${p}${NORMAL} found, not using as swap. (Force usage via boot option: anyswap)"
1045                      fi
1046                      ;;
1047                    *)
1048                      if [[ "$p" == LABEL* ]] ; then
1049                         p=$(blkid -t $p | awk -F: '{print $1}')
1050                      fi
1051                      if grep -q $p /proc/swaps ; then
1052                         ewarn "Not using swap partition ${WHITE}${p}${NORMAL} as it is already in use." ; eend 0
1053                      else
1054                         if [ -b "$p" ] ; then
1055                         einfo "Using swap partition ${WHITE}${p}${NORMAL}."
1056                         swapon $p 2>>$DEBUG ; eend $?
1057                         else
1058                         ewarn "$p is not a valid block device - not using it therefore." ; eend 0
1059                         fi
1060                      fi
1061                      ;;
1062              esac # dd-check
1063           fi # -n "$NOSWAP
1064           eoutdent
1065           continue
1066           ;;
1067         esac # it's a swap partition?
1068
1069         # mount read-only
1070         MOUNTOPTS="ro"
1071         case "$f" in
1072           vfat|msdos|ntfs) MOUNTOPTS="$MOUNTOPTS,uid=${fstabuser},gid=${fstabuser}" ;;
1073           ext2|ext3|reiserfs|jfs|reiser4|xfs) MOUNTOPTS="$MOUNTOPTS,noatime" ;;
1074           *) continue ;;
1075           # *) NONEFOUND='1'; continue ;;
1076         esac
1077
1078         # use a swapfile
1079         if [ -z "$NOSWAP" ] ; then
1080            mount -o "$MOUNTOPTS" -t $f $p $m 2>>$DEBUG && MOUNTED=1 || continue
1081            # Activate swapfile, if exists
1082            SWAPFILE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ss][Ww][Pp] 2>/dev/null)"
1083         fi
1084         if [ -z "$NOSWAP" -a -n "$SWAPFILE" -a -f "$SWAPFILE" ]; then
1085            mount -o remount,rw $m && MOUNTED=1
1086            if swapon "$SWAPFILE" 2>>$DEBUG ; then
1087               eindent
1088                 einfo "Using GRML swapfile ${WHITE}${SWAPFILE}${NORMAL}."
1089               eoutdent
1090               fnew="$SWAPFILE swap swap defaults 0 0"
1091               stringinfile "$fnew" "/etc/fstab" || echo "$fnew" >> /etc/fstab
1092               GRML_SWP="$GRML_SWP $SWAPFILE"
1093               eend 0
1094            fi
1095            mount -o remount,ro $m 2>>$DEBUG && MOUNTED=1
1096         fi
1097
1098         # use a image as home
1099         IMAGE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ii][Mm][Gg] 2>/dev/null)"
1100         if [ -z "$GRML_IMG" -a -n "$IMAGE" -a -f "$IMAGE" ]; then
1101            if [ -n "$HOMEDIR" ]; then
1102               if [ "$HOMEDIR" != "scan" -a "$HOMEDIR" != "$IMAGE" -a "$HOMEDIR" != "${IMAGE%/*.*}" ]; then
1103                  continue
1104               fi
1105            fi
1106            if type -a grml-image >/dev/null 2>&1 && grml-image "$IMAGE" </dev/console >/dev/console 2>&1; then
1107               GRML_IMG="$IMAGE"
1108               mount -o remount,ro $m 2>>$DEBUG && MOUNTED=1
1109            fi
1110         fi
1111         eend 0
1112
1113         # Umount, if not in use
1114         [ -n "$MOUNTED" ] && umount -r $m 2>/dev/null
1115
1116       done <<EOT
1117       $(cat /etc/fstab)
1118 EOT
1119    fi # -n $partitions
1120 fi # -z $INSTALLED
1121 }
1122 # }}}
1123
1124 # {{{ Mouse
1125 config_mouse(){
1126 if [ -n "$MOUSE_DEVICE" ] ; then
1127   einfo "Detecting mouse: ${MOUSE_FULLNAME} at ${MOUSE_DEVICE}" ; eend $?
1128 fi
1129 }
1130 # }}}
1131
1132 # {{{ IPv6 configuration
1133 # Load IPv6 kernel module and print IP adresses
1134 config_ipv6(){
1135 if checkbootparam "ipv6"; then
1136   einfo "Enabling IPv6 as requested on boot commandline (sleeping for 2 seconds)"
1137   modprobe ipv6
1138   # we probably need some time until stateless autoconfiguration has happened
1139   sleep 2
1140   NETDEVICES="$(awk -F: '/eth.:|tr.:|wlan.:/{print $1}' /proc/net/dev 2>>$DEBUG)"
1141   for DEVICE in `echo "$NETDEVICES"`; do
1142     eindent
1143       einfo "$DEVICE:"
1144       ADDRESSES="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{print $3}')"
1145       COUNT="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{ sum += 1};END {print sum }')"
1146       eindent
1147         for ADDR in `echo "$ADDRESSES"` ; do
1148             einfo "$ADDR"
1149         done
1150         if [ "$COUNT" -eq "0" ] ; then
1151            einfo "(none)" ; eend 1
1152         fi
1153       eoutdent
1154     eoutdent
1155   done
1156   eend 0
1157 fi
1158 }
1159 # }}}
1160
1161 # {{{ Fat-Client-Version: DHCP Broadcast for IP address
1162 config_dhcp(){
1163 if checkbootparam "nodhcp"; then
1164   ewarn "Skipping DHCP broadcast/network detection as requested on boot commandline." ; eend 0
1165 else
1166   NETDEVICES="$(awk -F: '/eth.:|tr.:|wlan.:/{print $1}' /proc/net/dev 2>>$DEBUG)"
1167   rm -rf /etc/network/status ; mkdir -p /etc/network/status
1168   for DEVICE in `echo "$NETDEVICES"` ; do
1169     einfo "Network device ${WHITE}${DEVICE}${NORMAL} detected, DHCP broadcasting for IP. (Backgrounding)"
1170     trap 2 3 11
1171     ifconfig $DEVICE up >>$DEBUG 2>&1
1172     ( pump -i $DEVICE >>$DEBUG 2>&1 && echo finished_running_pump > /etc/network/status/$DEVICE ) &
1173     trap "" 2 3 11
1174     sleep 1
1175     eend 0
1176   done
1177   if [ -n "$INSTALLED" ] ; then
1178      ewarn 'If you want to disable automatic DHCP requests set CONFIG_DHCP=no in /etc/grml/autoconfig.'
1179      eend 0
1180   fi
1181 fi
1182 }
1183 # }}}
1184
1185 # {{{ helper functions
1186 findfile(){
1187 FOUND=""
1188 # search all partitions for a file in the root directory
1189 for i in /mnt/[sh]d[a-z] /mnt/[sh]d[a-z][1-9] /mnt/[sh]d[a-z][1-9]?*; do
1190 # See if it's already mounted
1191   [ -f "$i/$1" ] &&  { echo "$i/$1"; return 0; }
1192   if [ -d "$i" ] && mount -r "$i" 2>>$DEBUG; then
1193     [ -f "$i/$1" ] && FOUND="$i/$1"
1194     umount -l "$i" 2>>$DEBUG
1195     [ -n "$FOUND" ] && { echo "$FOUND"; return 0; }
1196   fi
1197 done
1198 return 2
1199 }
1200
1201 fstype(){
1202 case "$(file -s $1)" in
1203   *[Ff][Aa][Tt]*|*[Xx]86*) echo "vfat"; return 0;;
1204   *[Rr][Ee][Ii][Ss][Ee][Rr]*)  echo "reiserfs"; return 0;;
1205   *[Xx][Ff][Ss]*)  echo "xfs"; return 0;;
1206   *[Ee][Xx][Tt]3*) echo "ext3"; return 0;;
1207   *[Ee][Xx][Tt]2*) echo "ext2"; return 0;;
1208   *data*)          echo "invalid"; return 0;;
1209   *) echo "auto"; return 0;;
1210 esac
1211 }
1212
1213 # Try to mount this filesystem read-only, without or with encryption
1214 trymount(){
1215 # Check if already mounted
1216 case "$(cat /proc/mounts)" in *\ $2\ *) return 0;; esac
1217 # Apparently, mount-aes DOES autodetect AES loopback files.
1218 [ -b "$1" ] && { mount -t auto -o ro "$1" "$2" 2>>$DEBUG; RC="$?"; }
1219 # We need to mount crypto-loop files with initial rw support
1220 [ -f "$1" ] && { mount -t auto -o loop,rw "$1" "$2" 2>>$DEBUG; RC="$?"; }
1221 # Mount succeeded?
1222 [ "$RC" = "0" ] && return 0
1223 echo ""
1224 einfo "Filesystem not autodetected, trying to mount $1 with AES256 encryption."
1225 a="y"
1226 while [ "$a" != "n" -a "$a" != "N" ]; do
1227 # We need to mount crypto-loop files with initial rw support
1228  mount -t auto -o loop,rw,encryption=AES256 "$1" "$2" && return 0
1229  echo -n "${RED}Mount failed, retry? [Y/n] ${NORMAL}"
1230  # Problem with ioctl() from getpasswd()?
1231  # read a
1232  read a
1233 done
1234 return 1
1235 }
1236 # }}}
1237
1238 # {{{ CPU-detection
1239 config_cpu(){
1240 if checkbootparam "nocpu"; then
1241   ewarn "Skipping CPU detection as requested on boot commandline." ; eend 0
1242 else
1243   # check module dependencies
1244   cpufreq_check() {
1245    if ! [ -e /lib/modules/${KERNEL}/kernel/arch/x86/kernel/cpu/cpufreq ] ; then
1246       if [ -e /lib64 ] ; then
1247          [ -e /lib/modules/${KERNEL}/kernel/arch/x86_64/kernel/cpufreq ] || return 1
1248       else
1249          [ -e /lib/modules/${KERNEL}/kernel/arch/i386/kernel/cpu/cpufreq -o ! -e /lib/modules/${KERNEL}/kernel/drivers/cpufreq ] || return 1
1250       fi
1251    fi
1252   }
1253
1254   if [[ `grep -c processor /proc/cpuinfo` -gt 1 ]] ; then
1255      einfo "Detecting CPU:"
1256      CPU=$(awk -F: '/^processor/{printf "       Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG)
1257      echo $CPU | sed 's/ \{1,\}/ /g'
1258      eend 0
1259   else
1260      einfo "Detecting CPU: `awk -F: '/^processor/{printf " Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG` " ; eend 0
1261   fi
1262
1263   # Disclaimer: sorry for the tons of if/then/else... but this makes sure we use:
1264   # * it only if we have the according kernel modules available
1265   # * cpufreq only on laptops (check via /usr/sbin/laptop-detect) and not inside Virtual Box
1266   # * current version of /etc/init.d/loadcpufreq from Debian (to stay in sync)
1267   #   -> parse output of the initscript and output it according to our look'n'feel
1268   # * our own cpufreq-detect.sh if /etc/init.d/loadcpufreq isn't present
1269   if ! cpufreq_check ; then
1270     ewarn "Skipping cpufreq setup as module dependencies are not fulfilled." ; eend 1
1271   else
1272     if /usr/sbin/laptop-detect 1>/dev/null 2>&1 ; then
1273        # Virtual Box supports ACPI and laptop-detect returns with '0', so check for it:
1274        if [ -r /proc/acpi/battery/BAT0/info ] ; then
1275           if grep -q 'OEM info:                innotek' /proc/acpi/battery/BAT0/info ; then
1276              einfo 'Virtual Box detected, skipping cpufreq setup.' ; eend 0
1277              return 0
1278           fi
1279        fi
1280        einfo "Detected Laptop - trying to use cpu frequency scaling:"
1281        eindent
1282        if [ -x /etc/init.d/loadcpufreq ] ; then
1283           SKIP_CPU_GOVERNOR=''
1284           LOADCPUFREQ=$(mktemp)
1285           /etc/init.d/loadcpufreq start >"$LOADCPUFREQ" 2>&1 ; RC=$?
1286           if grep -q FATAL "$LOADCPUFREQ" ; then
1287              eindent
1288                SKIP_CPU_GOVERNOR=1
1289                oldIFS="$IFS"
1290                IFS="
1291 "
1292                 for line in $(grep FATAL "$LOADCPUFREQ" | sed 's/.*FATAL: //; s/ (.*)//') ; do
1293                     eerror "$line" ; eend $RC
1294                 done
1295                 IFS="$oldIFS"
1296              eoutdent
1297            elif grep -q done "$LOADCPUFREQ" ; then
1298              MODULE=$(grep done "$LOADCPUFREQ" | sed 's/.*done (\(.*\))./\1/')
1299              if [ -n "$MODULE" -a "$MODULE" != none ]; then
1300                 einfo "Loading cpufreq kernel module $MODULE" ; eend 0
1301              else
1302                 ewarn "Could not find an appropriate kernel module for cpu frequency scaling." ; eend 1
1303              fi
1304           fi
1305           rm -f $LOADCPUFREQ
1306        elif [ -r /usr/bin/cpufreq-detect.sh ] ; then
1307           . /usr/bin/cpufreq-detect.sh
1308           if [ -n "$MODULE" -a "$MODULE" != none ]; then
1309              einfo "Loading modules ${MODULE}"
1310              modprobe "$MODULE" 1>>$DEBUG || modprobe "$MODULE_FALLBACK" 1>>$DEBUG
1311              RC=$?
1312              if [[ $RC == 0 ]]; then
1313                 eend 0
1314              else
1315                 SKIP_CPU_GOVERNOR=1
1316                 eend $1
1317              fi
1318           else
1319              ewarn "Could not detect an appropriate CPU for use with cpu frequency scaling - skipping." && eend 1
1320           fi # $MODULE
1321        fi # loadcpufreq
1322
1323        if [ -z "$SKIP_CPU_GOVERNOR" ] ; then
1324           einfo "Loading cpufreq_ondemand, setting ondemand governor"
1325           if modprobe cpufreq_ondemand ; RC=$? ; then
1326              for file in $(find /sys/devices/system/cpu/ -name scaling_governor 2>/dev/null) ; do
1327                  echo ondemand > $file
1328              done
1329           fi
1330           eend $RC
1331        fi # cpu-governor
1332
1333        eoutdent
1334
1335     fi # laptop-detect
1336   fi # cpufreq_check
1337 fi # checkbootparam nocpu
1338 }
1339 # }}}
1340
1341 # {{{ autostart of ssh
1342 config_ssh(){
1343 if checkbootparam ssh ; then
1344    SSH_PASSWD=''
1345    SSH_PASSWD="$(getbootparam 'ssh' 2>>$DEBUG)"
1346    einfo "Bootoption ssh found, trying to set password for user grml."
1347    eindent
1348    if [ -z "$SSH_PASSWD" ] ; then
1349       if [ -x /usr/bin/pwgen ] ; then
1350          SSH_PASSWD="$(pwgen -1 8)"
1351       elif [ -x /usr/bin/hexdump ] ; then
1352          SSH_PASSWD="$(dd if=/dev/urandom bs=14 count=1 2>/dev/null | hexdump | awk '{print $3 $4}')"
1353       elif [ -n "$RANDOM" ] ; then
1354          SSH_PASSWD="grml${RANDOM}"
1355       else
1356          SSH_PASSWD=''
1357          eerror "Empty passphrase and neither pwgen nor hexdump nor \$RANDOM found. Skipping."
1358          eend 1
1359       fi
1360
1361       if [ -n "$SSH_PASSWD" ] ; then
1362          ewarn "No given password for ssh found. Using random password: $SSH_PASSWD" ; eend 0
1363       fi
1364    fi
1365    eoutdent
1366
1367    # finally check if we have a password we can use:
1368    if [ -n "$SSH_PASSWD" ] ; then
1369       echo "grml:$SSH_PASSWD" | chpasswd -m
1370    fi
1371
1372    einfo 'Starting secure shell server in background.'
1373    /etc/init.d/rmnologin start 1>>$DEBUG 2>>$DEBUG
1374    /etc/init.d/ssh start 1>>$DEBUG 2>>$DEBUG &
1375    eend $?
1376
1377    eindent
1378    ewarn 'Warning: please change the password for user grml as soon as possible!'
1379    eoutdent
1380 fi
1381 }
1382 # }}}
1383
1384 # {{{ set password for user grml
1385 config_passwd(){
1386 if checkbootparam passwd >>$DEBUG 2>&1; then
1387   einfo "Bootoption passwd found."
1388   PASSWD="$(getbootparam 'passwd' 2>>$DEBUG)"
1389   if [ -n "$PASSWD" ] ; then
1390     echo "grml:$PASSWD" | chpasswd -m ; eend $?
1391   else
1392     eerror "No given password for ssh found. Autostart of SSH will not work." ; eend 1
1393   fi
1394   eindent
1395     ewarn "Warning: please change the password for user grml set via bootparameter as soon as possible!"
1396   eoutdent
1397 fi
1398 }
1399 # }}}
1400
1401 # {{{ Check for persistent homedir option and eventually mount /home from there, or use a loopback file.
1402 config_homedir(){
1403 if checkbootparam home ; then
1404    HOMEDIR="$(getbootparam home)"
1405    MYHOMEDEVICE=""
1406    MYHOMEMOUNTPOINT=""
1407    MYHOMEDIR=""
1408    if [ -n "$HOMEDIR" ]; then
1409       einfo "Bootoption home detected." && eend 0
1410       case "$HOMEDIR" in
1411         /dev/*)
1412         MYHOMEDEVICE="${HOMEDIR##/dev/}"
1413         MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
1414         MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
1415         MYHOMEDIR="/mnt/${HOMEDIR##/dev/}"
1416       ;;
1417         /mnt/*)
1418         MYHOMEDEVICE="${HOMEDIR##/mnt/}"
1419         MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
1420         MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
1421         MYHOMEDIR="$HOMEDIR"
1422       ;;
1423         [Aa][Uu][Tt][Oo]|[Ss][Cc][Aa][Nn]|[Ff][Ii][Nn][Dd])
1424         MYHOMEDIR="$(findfile grml.img)"
1425         MYHOMEDEVICE="${MYHOMEDIR##/mnt/}"
1426         MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
1427         MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
1428       ;;
1429       *)
1430         eerror "Invalid home= option '$HOMEDIR' specified (must start with /dev/ or /mnt/ or 'scan')." ; eend 1
1431         eerror "Option ignored." ; eend 1
1432       ;;
1433       esac
1434    fi # -n $HOMEDIR
1435
1436    if [ -n "$MYHOMEDIR" ]; then
1437       if trymount "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"; then
1438          [ -f "$MYHOMEMOUNTPOINT/grml.img" ] && MYHOMEDIR="$MYHOMEMOUNTPOINT/grml.img"
1439          while read device mountpoint fs relax; do
1440            case "$mountpoint" in *$MYHOMEMOUNTPOINT*)
1441              case "$fs" in
1442                *[Nn][Tt][Ff][Ss]*)
1443                  umount "$MYHOMEMOUNTPOINT"; eerror "Error: will not mount NTFS filesystem on $MYHOMEDEVICE read/write!" ; eend 1
1444                  break
1445                  ;;
1446                *[Ff][Aa][Tt]*)
1447                  # Note: This currently won't work with encrypted partitions
1448                  umount "$MYHOMEMOUNTPOINT"; mount -t vfat -o rw,uid=grml,gid=grml,umask=002 "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"
1449                  if [ ! -f "$MYHOMEDIR" ]; then
1450                     ewarn "WARNING: FAT32 is not a good filesystem option for /home/grml (missing socket/symlink support)."
1451                     ewarn "WARNING: Better use an ext2 loopback file on this device, and boot with home=$MYHOMEDEVICE/grml.img."
1452                  fi
1453                  ;;
1454              esac
1455
1456              if mount -o remount,rw "$MYHOMEMOUNTPOINT"; then
1457                 einfo "Mounting ${WHITE}$MYHOMEDIR${NORMAL} as ${WHITE}/home/grml${NORMAL}."
1458                 if [ -f "$MYHOMEDIR" ]; then
1459                    # It's a loopback file, mount it over the /home/grml directory
1460                    trymount "$MYHOMEDIR" /home/grml
1461                    RC="$?"
1462                    [ "$RC" = "0" ] && ERROR="$(mount -o remount,rw /home/grml 2>&1)"
1463                    RC="$?"
1464                 else
1465                    # Do a --bind mount
1466                    ERROR="$(mount --bind "$MYHOMEDIR" /home/grml 2>&1)"
1467                    RC="$?"
1468                 fi # -f $MYHOMEDIR
1469
1470                 [ "$RC" = "0" ] && eend 0 || ( eerror "${ERROR}" ; eend 1 )
1471
1472              fi #  mount -o remount,rw,...
1473            break
1474            ;;
1475            esac # case "$mountpoint" in *$MYHOMEMOUNTPOINT*)
1476          done <<EOT
1477          $(cat /proc/mounts)
1478 EOT
1479      fi # if trymount ...
1480    fi # -n $MYHOMEDIR
1481 fi # checkbootparam home
1482 }
1483 # }}}
1484
1485 # {{{ Check for scripts on CD-ROM
1486 config_cdrom_scripts(){
1487 if checkbootparam "script"; then
1488    for script in "${LIVECD_PATH}"/scripts/* ; do
1489        einfo " grml script found on CD, executing ${WHITE}${script}${NORMAL}."
1490        . $script
1491    done
1492 fi
1493 }
1494 # }}}
1495
1496 # {{{ Sound
1497 config_mixer(){
1498 if ! [ -x /usr/bin/aumix ] ; then
1499   eerror "aumix binary not available. Can not set sound volumes therefore." ; eend 1
1500 else
1501
1502   if ! [ -r /proc/asound/cards ] ; then
1503      ewarn "No soundcard present, skipping mixer settings therefore." ; eend 0
1504      return
1505   fi
1506
1507   if checkbootparam vol ; then
1508     VOL="$(getbootparam 'vol' 2>>$DEBUG)"
1509     if [ -z "$VOL" ] ; then
1510       eerror "Bootoption vol found but no volume level/parameter given. Using defaults." ; eend 1
1511       VOL='75' # default
1512     fi
1513   else
1514     VOL='75' # default
1515   fi
1516
1517   if checkbootparam nosound ; then
1518     einfo "Muting sound devices on request."
1519     # some IBM notebooks require the following stuff:
1520     if [ -x /usr/bin/amixer ] ; then
1521        if amixer get Front 1>/dev/null 2>>$DEBUG ; then
1522           amixer set Front unmute 1>/dev/null
1523           amixer set Front 0% 1>/dev/null
1524        fi
1525     fi
1526     ERROR=$(aumix -w 0 -v 0 -p 0 -m 0 2>&1) ; RC=$?
1527     if [ -n "$ERROR" ] ; then
1528        eindent
1529        eerror "Problem muting sound devices: $ERROR"
1530        eoutdent
1531     fi
1532     eend $RC
1533   elif [ -z "$INSTALLED" ]; then
1534       einfo "Setting mixer volumes to level ${WHITE}${VOL}${NORMAL}."
1535       # some IBM notebooks require the following stuff:
1536       if [ -x /usr/bin/amixer ] ; then
1537          if amixer get Front 1>/dev/null 2>>$DEBUG ; then
1538             amixer set Front unmute 1>/dev/null
1539             amixer set Front ${VOL}% 1>/dev/null
1540          fi
1541       fi
1542       # by default assume '0' as volume for microphone:
1543       if checkbootparam micvol ; then
1544          MICVOL="$(getbootparam 'micvol' 2>>$DEBUG)"
1545       else
1546          MICVOL=0
1547       fi
1548
1549       # finally set the volumes:
1550       ERROR=$(aumix -w $VOL -v $VOL -p $VOL -m $MICVOL 2>&1) ; RC=$?
1551       if [ -n "$ERROR" ] ; then
1552          eindent
1553          eerror "Problem setting mixer volumes: $ERROR (no soundcard?)"
1554          eoutdent
1555       fi
1556       eend $RC
1557   fi
1558
1559 fi
1560 }
1561 # }}}
1562
1563 # {{{ modem detection
1564 config_modem(){
1565 if checkbootparam "nomodem"; then
1566   ewarn "Skipping check for AC97 modem controller as requested on boot commandline." ; eend 0
1567 else
1568   if [ -x /etc/init.d/sl-modem-daemon ] ; then
1569      if lspci | grep Intel | grep -q "AC'97 Modem Controller" ; then
1570         einfo "AC97 modem controller detected. Start it running 'Start sl-modem-daemon'."
1571         eend 0
1572      fi
1573   fi
1574 fi
1575 }
1576 # }}}
1577
1578 # {{{ keyboard add-ons
1579 config_setkeycodes(){
1580 if checkbootparam "setkeycodes" ; then
1581  einfo "Setting keycodes as requested via bootparameter 'setkeycodes'."
1582   # MS MM keyboard add-on
1583   # fix
1584   setkeycodes e001 126 &>/dev/null
1585   setkeycodes e059 127 &>/dev/null
1586   # fn keys
1587   setkeycodes e03b 59 &>/dev/null
1588   setkeycodes e008 60 &>/dev/null
1589   setkeycodes e007 61 &>/dev/null
1590   setkeycodes e03e 62 &>/dev/null
1591   setkeycodes e03f 63 &>/dev/null
1592   setkeycodes e040 64 &>/dev/null
1593   setkeycodes e041 65 &>/dev/null
1594   setkeycodes e042 66 &>/dev/null
1595   setkeycodes e043 67 &>/dev/null
1596   setkeycodes e023 68 &>/dev/null
1597   setkeycodes e057 87 &>/dev/null
1598   setkeycodes e058 88 &>/dev/null
1599   # hp keycodes
1600   setkeycodes e00a 89 e008 90 &>/dev/null
1601  eend 0
1602 fi
1603 }
1604 # }}}
1605
1606 # {{{ wondershaper
1607 config_wondershaper(){
1608  if checkbootparam "wondershaper" ; then
1609     WONDER="$(getbootparam wondershaper 2>>$DEBUG)"
1610     CMD=wondershaper
1611     DEVICE=""
1612     DOWNSTREAM=""
1613     UPSTREAM=""
1614     if [ -n "$WONDER" ]; then
1615       # Extra options
1616       DEVICE="${WONDER%%,*}"
1617       R="${WONDER#*,}"
1618       if [ -n "$R" -a "$R" != "$WONDER" ]; then
1619         WONDER="$R"
1620         DOWNSTREAM="${WONDER%%,*}"
1621         R="${WONDER#*,}"
1622         if [ -n "$R" -a "$R" != "$WONDER" ]; then
1623           WONDER="$R"
1624           UPSTREAM="${WONDER%%,*}"
1625           R="${WONDER#*,}"
1626         fi
1627       fi
1628     fi
1629     [ -n "$DEVICE" ]     && CMD="$CMD $DEVICE"
1630     [ -n "$DOWNSTREAM" ] && CMD="$CMD $DOWNSTREAM"
1631     [ -n "$UPSTREAM" ]   && CMD="$CMD $UPSTREAM"
1632     einfo "Starting wondershaper (${CMD}) in background."
1633     ( sh -c $CMD & ) && eend 0
1634  fi
1635 }
1636 # }}}
1637
1638 # {{{ syslog-ng
1639 config_syslog(){
1640  if checkbootparam "nosyslog"; then
1641     ewarn "Not starting syslog daemon as requested on boot commandline." ; eend 0
1642  else
1643     SYSLOGD=''
1644     [ -x /etc/init.d/syslog-ng ] && SYSLOGD='syslog-ng'
1645     [ -x /etc/init.d/rsyslog   ] && SYSLOGD='rsyslog'
1646     [ -x /etc/init.d/dsyslog   ] && SYSLOGD='dsyslog'
1647     [ -x /etc/init.d/sysklogd  ] && SYSLOGD='sysklogd'
1648     [ -x /etc/init.d/inetutils-syslogd ] && SYSLOGD='inetutils-syslogd'
1649
1650     if [ -z "$SYSLOGD" ] ; then
1651        eerror "No syslog daemon found." ; eend 1
1652     else
1653        einfo "Starting $SYSLOGD in background."
1654        /etc/init.d/$SYSLOGD start 1>>$DEBUG &
1655        eend 0
1656     fi
1657  fi
1658 }
1659 # }}}
1660
1661 # {{{ gpm
1662 config_gpm(){
1663  if checkbootparam "nogpm"; then
1664   ewarn "Not starting GPM as requested on boot commandline." ; eend 0
1665  else
1666    if ! [ -r /dev/input/mice ] ; then
1667       eerror "No mouse found - not starting GPM." ; eend 1
1668    else
1669       einfo "Starting gpm in background."
1670       /etc/init.d/gpm start 1>>$DEBUG &
1671       # ( while [ ! -e /dev/psaux ]; do sleep 5; done; /etc/init.d/gpm start 1>>$DEBUG ) &
1672       eend 0
1673    fi
1674  fi
1675 }
1676 # }}}
1677
1678 # {{{ services
1679 config_services(){
1680  if checkbootparam "services" ; then
1681     SERVICE="$(getbootparam services 2>>$DEBUG)"
1682     SERVICELIST=$(echo "$SERVICE" | sed 's/,/\\n/g')
1683     SERVICENL=$(echo "$SERVICE" | sed 's/,/ /g')
1684     einfo "Starting service(s) ${SERVICENL} in background."
1685     for service in $(echo -e $SERVICELIST) ; do
1686        /etc/init.d/${service} start 1>>$DEBUG &
1687     done
1688     [ "$?" == "0" ] ; eend $?
1689  fi
1690 }
1691 # }}}
1692
1693 # {{{ config files
1694 config_netconfig(){
1695  if checkbootparam netconfig ; then
1696   CONFIG="$(getbootparam 'netconfig' 2>>$DEBUG)"
1697   CONFIGFILE='/tmp/netconfig.grml'
1698
1699   getconfig() {
1700   wget --timeout=10 --dns-timeout=10  --connect-timeout=10 \
1701        --read-timeout=10 $CONFIG -O $CONFIGFILE && return 0 || return 1
1702   }
1703   einfo "Trying to get ${WHITE}${CONFIG}${NORMAL}"
1704   counter=10
1705   while ! getconfig && [[ "$counter" != 0 ]] ; do
1706     echo -n "Sleeping for 5 seconds and trying to get config again... "
1707     counter=$(( counter-1 ))
1708     echo "$counter tries left" ; sleep 1
1709   done
1710   if [ -r "$CONFIGFILE" ] ; then
1711     einfo "Downloading was successfull." ; eend 0
1712     einfo "md5sum of ${WHITE}${CONFIG}${NORMAL}: "
1713     md5sum $CONFIGFILE ; eend 0
1714     cd / && einfo "Unpacking ${WHITE}${CONFIGFILE}${NORMAL}:" && /usr/bin/unp $CONFIGFILE $EXTRACTOPTIONS ; eend $?
1715   else
1716     einfo "Sorry, could not fetch $CONFIG" ; eend 1
1717   fi
1718  fi
1719 }
1720 # }}}
1721
1722 # {{{ blindsound
1723 config_blindsound(){
1724  if checkbootparam "blind" ; then
1725     beep
1726     flite -o play -t "welcome to the gremel system"
1727  fi
1728 }
1729 # }}}
1730
1731 # {{{ welcome sound
1732 config_welcome(){
1733  if checkbootparam welcome ; then
1734   flite -o play -t "welcome to the gremel system"
1735  fi
1736 }
1737 # }}}
1738
1739 # {{{ fix/workaround for unionfs
1740 fix_unionfs(){
1741   if [ -z "$INSTALLED" ]; then
1742    touch /var/cache/apt/*cache.bin
1743   fi
1744 }
1745 # }}}
1746
1747 # {{{ create all /mnt-directories
1748 create_mnt_dirs(){
1749   ewarn "create_mnt_dirs is deprecated as grml-rebuildfstab does all we need."
1750   ewarn "Please set CONFIG_CREATE_MNT_DIRS='no' in /etc/grml/autoconfig" ; eend 0
1751 }
1752 # }}}
1753
1754 # {{{ start X window system via grml-x
1755 config_x_startup(){
1756 if checkbootparam startx ; then
1757  if [ -x /usr/X11R6/bin/X ] ; then
1758   if [ -z "$INSTALLED" ] ; then
1759    WINDOWMANAGER="$(getbootparam 'startx' 2>>$DEBUG)"
1760    if [ -z "$WINDOWMANAGER" ] ; then
1761      einfo "No window manager specified. Taking ${WHITE}wm-ng${NORMAL} as default." && eend 0
1762      WINDOWMANAGER="wm-ng"
1763    else
1764      einfo "Window manager ${WHITE}${WINDOWMANAGER}${NORMAL} found as bootoption." && eend 0
1765    fi
1766    einfo "Changing to runlevel 5 for starting grml-x ${WINDOWMANAGER}. Just exit X windows system to get full featured consoles."
1767    config_userfstab || fstabuser='grml'
1768  cat>|/etc/init.d/xstartup<<EOF
1769 #!/bin/sh
1770 # su - $fstabuser -c 'grml-x "$WINDOWMANAGER"'
1771 sudo -u $fstabuser -i /usr/bin/grml-x $WINDOWMANAGER 1>>$DEBUG
1772 EOF
1773    chmod 755 /etc/init.d/xstartup
1774
1775    # adjust inittab for xstartup
1776    if grep -q '^6:' /etc/inittab ; then
1777       sed -i 's|^6:.*|6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /bin/zsh"|' /etc/inittab
1778    else # just append tty6 to inittab if no definition is present:
1779       echo '6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /bin/zsh"' >> /etc/inittab
1780    fi
1781
1782    /sbin/telinit q ; eend $?
1783
1784    if grep -q '^allowed_users=' /etc/X11/Xwrapper.config ; then
1785       sed -i 's/^allowed_users=.*/allowed_users=anybody/' /etc/X11/Xwrapper.config
1786    else
1787       echo 'allowed_users=anybody' >> /etc/X11/Xwrapper.config
1788    fi
1789
1790   else
1791     eerror "We are not running from CD - startx will not work, skipping it.
1792      Please use something like xdm, gdm or kdm for starting X on a harddisk system!" ; eend 1
1793   fi
1794  else
1795    eerror "/usr/X11R6/bin/X is not present on this grml flavour.
1796    Boot parameter startx does not work therefore." ; eend 1
1797  fi
1798 fi
1799 }
1800 # }}}
1801
1802 # {{{ configuration framework
1803 config_extract(){
1804 if checkbootparam extract ; then
1805  EXTRACT="$(getbootparam 'extract' 2>>$DEBUG)"
1806  EXTRACTOPTIONS="-- -x $EXTRACT"
1807 fi
1808 }
1809
1810 config_automount(){
1811 if checkbootparam noautoconfig || checkbootparam forensic ; then
1812   ewarn "Skipping running automount of device(s) labeled GRMLCFG as requested." ; eend 0
1813 else
1814  if [ -z "$INSTALLED" ] ; then
1815   einfo "Searching for device(s) labeled with GRMLCFG. (Disable this via boot option: noautoconfig)" ; eend 0
1816   eindent
1817   [ -d /mnt/grml ] || mkdir /mnt/grml
1818   umount /mnt/grml 1>>$DEBUG 2>&1 # make sure it is not mounted
1819 # We do need the following fix so floppy disk is available to blkid in any case :-/
1820   if [ -r /dev/fd0 ] ; then
1821      einfo "Floppy device detected. Trying to access floppy disk."
1822 #     dd if=/dev/fd0 of=/dev/null bs=512 count=1 1>>$DEBUG 2>&1
1823      if timeout 4 dd if=/dev/fd0 of=/dev/null bs=512 count=1 1>>$DEBUG 2>&1 ; then
1824         blkid /dev/fd0 1>>$DEBUG 2>&1
1825      fi
1826   fi
1827   DEVICE=$(blkid -t LABEL=GRMLCFG | head -1 | awk -F: '{print $1}')
1828   [ -n "$DEVICE" ] && mount -t auto -o ro $DEVICE /mnt/grml ; RC="$?"
1829   if [[ $RC == 0 ]]; then
1830     einfo "Mounting device $DEVICE labeled GRMLCFG succeeded." ; eend 0
1831
1832     CONFIG=''
1833     CONFIG="$(/bin/ls -1d /mnt/grml/[Cc][Oo][Nn][Ff][Ii][Gg].[Tt][Bb][Zz] 2>>$DEBUG)"
1834     if [ -n "$CONFIG" ]; then
1835       einfo "Found file ${WHITE}${CONFIG}${NORMAL} - trying to extract it."
1836       cd /
1837       unp $CONFIG $EXTRACTOPTIONS ; eend $?
1838     else
1839       ewarn "Sorry, could not find file config.tbz on device with label GRMLCFG." ; eend 1
1840     fi
1841
1842     SCRIPT=''
1843     SCRIPT="$(/bin/ls -1d /mnt/grml/[Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
1844     if [ -n "$SCRIPT" ]; then
1845       einfo "Found script ${WHITE}${SCRIPT}${NORMAL} - trying to execute it."
1846       $SCRIPT ; eend $?
1847     fi
1848     grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1849   else
1850     ewarn "No devices with label GRMLCFG found." ; eend 0
1851   fi
1852   eoutdent
1853  fi
1854 fi
1855 }
1856
1857 config_myconfig(){
1858
1859 if checkbootparam "config" ; then
1860   CONFIG="$(getbootparam 'config' 2>>$DEBUG)"
1861   [ -z "$CONFIG" ] && CONFIG='config.tbz'
1862   einfo "Bootoption config found. config is set to: $CONFIG"
1863   eindent
1864     einfo "Trying to extract configuration file ${CONFIG}:"
1865     cd / && unp "${LIVECD_PATH}"/config/$CONFIG $EXTRACTOPTIONS ; eend $?
1866   eoutdent
1867 fi
1868
1869 if checkbootparam myconfig ; then
1870  MOUNTDEVICE="$(getbootparam 'myconfig' 2>>$DEBUG)"
1871  if [ -n "$MOUNTDEVICE" ]; then
1872    if checkbootparam file ; then
1873     FILENAME="$(getbootparam 'file' 2>>$DEBUG)"
1874     [ -n "$FILENAME" ] || FILENAME='config.tbz'
1875    fi
1876    [ -d /mnt/grml ] || mkdir /mnt/grml
1877    umount /mnt/grml 1>>$DEBUG 2>&1 # make sure it is not mounted
1878    mount -o ro -t auto $MOUNTDEVICE /mnt/grml ; RC="$?"
1879     if [[ $RC == 0 ]]; then
1880       einfo "Successfully mounted $MOUNTDEVICE to /mnt/grml (readonly)." ; eend 0
1881       eindent
1882       CONFIG=''
1883       CONFIG="$(/bin/ls -1d /mnt/grml/[Cc][Oo][Nn][Ff][Ii][Gg].[Tt][Bb][Zz] 2>>$DEBUG)"
1884       if [ -n "$CONFIG" ]; then
1885         einfo "Found file ${WHITE}${CONFIG}${NORMAL} - trying to extract it."
1886         cd /
1887         unp $CONFIG $EXTRACTOPTIONS ; eend $?
1888       else
1889         ewarn "Sorry, could not find file config.tbz on device with label GRMLCFG." ; eend 1
1890       fi
1891
1892       SCRIPT=''
1893       SCRIPT="$(/bin/ls -1d /mnt/grml/[Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
1894       if [ -n "$SCRIPT" ]; then
1895         einfo "Found script ${WHITE}${SCRIPT}${NORMAL} - trying to execute it."
1896         $SCRIPT ; eend $?
1897       fi
1898       eoutdent
1899     else
1900       einfo "Could not mount $MOUNTDEVICE to /mnt/grml - sorry." ; eend 1
1901     fi # mount $MOUNTDEVICE
1902    grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1903  else
1904    einfo "Sorry, no device for bootoption myconfig provided. Skipping." ; eend 1
1905  fi # [ -n "$MOUNTDEVICE" ]
1906 fi # checkbootparam myconfig
1907
1908 if checkbootparam "partconf" ; then
1909  MOUNTDEVICE="$(getbootparam 'partconf' 2>>$DEBUG)"
1910  if [ -n "$MOUNTDEVICE" ]; then
1911    [ -d /mnt/grml ] || mkdir /mnt/grml
1912    mount -o ro -t auto $MOUNTDEVICE /mnt/grml ; RC="$?"
1913     if [[ $RC == 0 ]]; then
1914       einfo "Successfully mounted $MOUNTDEVICE to /mnt/grml (readonly)." ; eend 0
1915       einfo "Copying files from $MOUNTDEVICE over grml system."
1916       for file in `cat /etc/grml/partconf` ; do
1917         [ -d /mnt/grml/$file ] && cp -a /mnt/grml/${file}* ${file} && echo "copied: $file"
1918         [ -f /mnt/grml/$file ] && cp -a /mnt/grml/${file}  ${file} && echo "copied: $file"
1919       done && eend 0
1920     else
1921       einfo "Could not mount $MOUNTDEVICE to /mnt/grml - sorry." ; eend 1
1922     fi # mount $MOUNTDEVICE
1923    grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1924  else
1925    einfo "Sorry, no device for bootoption partconf provided. Skipping." ; eend 1
1926  fi # [ -n "$MOUNTDEVICE" ]
1927 fi
1928 }
1929 # }}}
1930
1931 # {{{ /cdrom/.*-options
1932 config_debs(){
1933 if checkbootparam "debs" ; then
1934    DEBS="$(getbootparam 'debs' 2>>$DEBUG)"
1935    einfo "Tring to install debian package(s) ${DEBS}"
1936    dpkg -i "${LIVECD_PATH}"/debs/$DEBS* ; eend $?
1937 fi
1938 }
1939
1940 config_scripts(){
1941 if checkbootparam "scripts" ; then
1942    SCRIPTS="$(getbootparam 'scripts' 2>>$DEBUG)"
1943    [ -z "$SCRIPTS" ] && SCRIPTS='grml.sh'
1944    einfo "Bootparameter scripts found. Trying to execute ${SCRIPTS}:"
1945    sh -c "${LIVECD_PATH}"/scripts/$SCRIPTS ; eend $?
1946 fi
1947 }
1948 # }}}
1949
1950 # {{{ mypath
1951 config_mypath(){
1952 if checkbootparam "mypath" ; then
1953    MY_PATH="$(getbootparam 'mypath' 2>>$DEBUG)"
1954    einfo "Bootparameter mypath found, adding ${MY_PATH} to /etc/grml/my_path"
1955    touch /etc/grml/my_path
1956    chmod 644 /etc/grml/my_path
1957    # make sure the directories exist:
1958    eindent
1959    for i in $(echo $MY_PATH | sed 's/:/\n/g') ; do
1960        if ! [ -d "$i" ] ; then
1961           einfo "Creating directory $i"
1962           mkdir -p "$i" ; eend $?
1963        fi
1964    done
1965    grep -q "${MY_PATH}" /etc/grml/my_path || echo "${MY_PATH}" >> /etc/grml/my_path ; eend $?
1966    eoutdent
1967 fi
1968 }
1969 # }}}
1970
1971 # {{{ distcc
1972 config_distcc(){
1973 if checkbootparam "distcc" ; then
1974  OPTIONS="$(getbootparam distcc 2>>$DEBUG)"
1975  if [ -n "$OPTIONS" ]; then
1976     NET=""
1977     INTERFACE=""
1978     if [ -n "$OPTIONS" ]; then
1979       NET="${OPTIONS%%,*}"
1980       R="${OPTIONS#*,}"
1981       if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
1982         OPTIONS="$R"
1983         INTERFACE="${OPTIONS%%,*}"
1984         R="${OPTIONS#*,}"
1985       fi
1986     fi
1987  fi
1988  CONFIG=/etc/default/distcc
1989  sed -i "s#^STARTDISTCC=.*#STARTDISTCC=YES#"  $CONFIG
1990  sed -i "s#^ALLOWEDNETS=.*#ALLOWEDNETS=$NET#" $CONFIG
1991
1992  if [ -n "$INTERFACE" ] ; then
1993    IP=$(LANG=C ifconfig $INTERFACE | gawk -F: /"inet addr"/'{print $2}' | gawk '{print $1}')
1994
1995    counter=10
1996    while [ -z "$IP" ] && [[ "$counter" != 0 ]] ; do
1997      counter=$(( counter-1 ))
1998      ewarn "No ip address for $INTERFACE found. Sleeping for 3 seconds. $counter tries left."
1999      sleep 3
2000      IP=$(LANG=C ifconfig $INTERFACE | gawk -F: /"inet addr"/'{print $2}' | gawk '{print $1}')
2001    done
2002  fi
2003
2004  if [ -n "$IP" ] ; then
2005    sed -i "s#^LISTENER=.*#LISTENER=$IP#"      $CONFIG
2006
2007    einfo "Bootoption distcc found. Preparing setup for distcc daemon."
2008    eindent
2009     id distccd >/dev/null 2>&1 || \
2010     (
2011       einfo "Creating distcc user" ; \
2012       adduser --quiet --system --ingroup nogroup --home / --no-create-home distccd ; eend $?
2013     )
2014
2015     einfo "Starting distcc for network ${NET}, listening on ${IP}."
2016    /etc/init.d/distcc start 1>/dev/null ; eend $?
2017    eoutdent
2018  else
2019    eerror "No ip address for $INTERFACE found. distcc can not be used without it." ; eend 1
2020  fi
2021 fi
2022
2023 if checkbootparam "gcc"; then
2024  GCC="$(getbootparam gcc 2>>$DEBUG)"
2025  eindent
2026  einfo "Pointing /usr/bin/gcc to /usr/bin/gcc-${GCC}."
2027  eoutdent
2028  rm -f /usr/bin/gcc
2029  ln -s /usr/bin/gcc-${GCC} /usr/bin/gcc ; eend $?
2030 fi
2031
2032 if checkbootparam "gpp"; then
2033  GPP="$(getbootparam gpp 2>>$DEBUG)"
2034  eindent
2035   einfo "Pointing /usr/bin/g++ to /usr/bin/g++-${GPP}."
2036   if [ -x /usr/bin/g++-${GPP} ] ; then
2037      rm -f /usr/bin/g++
2038      ln -s /usr/bin/g++-${GPP} /usr/bin/g++ ; eend $?
2039   fi
2040   einfo "Pointing /usr/bin/cpp to /usr/bin/cpp-${GPP}."
2041   if [ -x /usr/bin/cpp-${GPP} ] ; then
2042      rm -f /usr/bin/cpp
2043      ln -s /usr/bin/cpp-${GPP} /usr/bin/cpp ; eend $?
2044   fi
2045  eoutdent
2046 fi
2047
2048 }
2049 # }}}
2050
2051 # {{{ load modules
2052 # Notice: use it only on live-cd system, if running from harddisk please
2053 # add modules to /etc/modules and activate /etc/init.d/module-init-tools
2054 # in /etc/runlevel.conf
2055 config_modules(){
2056 MODULES_FILE=/etc/grml/modules
2057 if checkbootparam nomodules ; then
2058   ewarn "Skipping loading of modules defined in ${MODULES_FILE} as requested." ; eend 0
2059 elif [ -z "$INSTALLED" ]; then
2060  if [ -r $MODULES_FILE ] ; then
2061   einfo "Loading modules specified in ${MODULES_FILE}:"
2062   eindent
2063   grep '^[^#]' $MODULES_FILE | \
2064   while read module args; do
2065     [ "$module" ] || continue
2066       einfo "${module}"
2067       modprobe $module $args ; eend $?
2068   done
2069   eoutdent
2070  else
2071   ewarn "File $MODULES_FILE does not exist. Skipping loading of specific modules." ; eend 1
2072  fi
2073 fi
2074 }
2075 # }}}
2076
2077 # {{{ 915resolution
2078 config_915resolution(){
2079 if checkbootparam "915resolution" ; then
2080  OPTIONS="$(getbootparam 915resolution 2>>$DEBUG)"
2081   if [ -x /usr/sbin/915resolution ]; then
2082     CMD=915resolution
2083     MODE=""
2084     XRESO=""
2085     YRESO=""
2086     if [ -n "$OPTIONS" ]; then
2087       # Extra options
2088       MODE="${OPTIONS%%,*}"
2089       R="${OPTIONS#*,}"
2090       if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
2091         OPTIONS="$R"
2092         XRESO="${OPTIONS%%,*}"
2093         R="${OPTIONS#*,}"
2094         if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
2095           OPTIONS="$R"
2096           YRESO="${OPTIONS%%,*}"
2097           R="${OPTIONS#*,}"
2098         fi
2099       fi
2100     fi
2101     einfo "Running 915resolution with options ${MODE} ${XRESO} ${YRESO}."
2102     [ -n "$MODE" ] && [ -n "$XRESO"  ] && [ -n "$YRESO" ]  && ( sh -c "$CMD $MODE $XRESO $YRESO" & )
2103     eend 0
2104   fi
2105 fi
2106 }
2107 # }}}
2108
2109 # {{{ SW-RAID
2110 config_swraid(){
2111   if [ -z "$INSTALLED" ] ; then
2112   # notice: checkbootparam "forensic" is just for users who don't know how to really use the bootoption
2113   if checkbootparam 'noraid'   || checkbootparam 'noswraid' -o \
2114      checkbootparam 'forensic' || checkbootparam 'raid=noautodetect' ; then
2115      ewarn "Skipping SW-RAID code as requested on boot commandline." ; eend 0
2116   else
2117     if ! [ -x /sbin/mdadm ] ; then
2118        eerror "mdadm not available, can not execute it." ; eend 1
2119     else
2120
2121        # if ! egrep -qv '^(MAILADDR.*|#.*|)$' /etc/mdadm/mdadm.conf 2>>$DEBUG ; then
2122        # find out whether we have a valid configuration file already
2123        if ! grep -q ARRAY /etc/mdadm/mdadm.conf 2>>$DEBUG ; then
2124           einfo "Creating /etc/mdadm/mdadm.conf for use with mdadm."
2125           [ -r /etc/mdadm/mdadm.conf ] && mv /etc/mdadm/mdadm.conf /etc/mdadm/mdadm.conf.old
2126           MDADM_MAILADDR__='root' /usr/share/mdadm/mkconf > /etc/mdadm/mdadm.conf ; eend $?
2127         else
2128           ewarn "/etc/mdadm/mdadm.conf looks like a configured mdadm setup, will not touch it." ; eend 0
2129        fi
2130
2131        if ! checkbootparam 'swraid' ; then
2132           eindent
2133           einfo "Just run 'Start mdadm-raid' to assemble md arrays or boot using 'swraid' as bootoption for autostart."
2134           eoutdent
2135        else
2136           einfo "Bootoption swraid found. Searching for software RAID arrays:"
2137           eindent
2138            IFSOLD=${IFS:-}
2139            IFS='
2140 '
2141            for line in $(mdadm --assemble --scan --auto=yes --symlink=no 2>&1) ; do
2142                case $line in
2143                  *'No arrays found'*)
2144                    ewarn "$line" ; eend 0
2145                    ;;
2146                  *)
2147                    einfo "$line" ; eend 0
2148                    ;;
2149                esac
2150            done
2151            IFS=$IFSOLD
2152          eoutdent
2153
2154          if [ -r /proc/mdstat ] ; then
2155             eindent
2156             MDSTAT=$(grep '^md[0-9]' /proc/mdstat)
2157             if [ -z "$MDSTAT" ] ; then
2158                ewarn "No active arrays found" ; eend 0
2159             else
2160                IFSOLD=${IFS:-}
2161                IFS='
2162 '
2163                for line in $(grep '^md[0-9]' /proc/mdstat) ; do
2164                    einfo "active arrays: $line" ; eend 0
2165                done
2166                IFS=$IFSOLD
2167             fi
2168             eoutdent
2169          fi # /proc/mdstat
2170        fi # bootoption swraid
2171
2172      fi # is /sbin/mdadm executable?
2173   fi # check for bootoptions
2174   fi # run only in live-cd mode
2175 }
2176 # }}}
2177
2178 # {{{ LVM (Logical Volumes)
2179 config_lvm(){
2180   if [ -z "$INSTALLED" ] ; then
2181   # notice: checkbootparam "forensic" is just for users who don't know how to really use the bootoption
2182   if checkbootparam 'nolvm' ; then
2183      ewarn "Skipping LVM code as requested on boot commandline." ; eend 0
2184   else
2185     # Debian etch provides /etc/init.d/lvm only, newer suites provide /etc/init.d/lvm2
2186     if ! [ -x /sbin/lvm -a -x /sbin/lvdisplay ] || ! [ -x /etc/init.d/lvm2 -o -x /etc/init.d/lvm ] ; then
2187        eerror "LVM not available, can not execute it." ; eend 1
2188     else
2189        if lvdisplay 2>&1 | grep -v 'No volume groups found' 1>/dev/null 2>&1 ; then
2190           einfo "You seem to have logical volumes (LVM) on your system."
2191           eindent
2192           einfo "Just run 'Start lvm2' to activate them or boot using 'lvm' as bootoption for autostart."
2193           eend 0
2194           if checkbootparam 'lvm' ; then
2195              einfo "Bootoption LVM found. Searching for logical volumes:"
2196              /etc/init.d/lvm2 start ; eend $?
2197           fi
2198           eoutdent
2199        fi
2200     fi # check for lvm binary
2201   fi # check for bootoption nolvm
2202   fi # run only in live-cd mode
2203 }
2204 # }}}
2205
2206 # {{{ debnet: setup network based on an existing one found on a partition
2207 config_debnet(){
2208 if checkbootparam "debnet" ; then
2209  iszsh && setopt shwordsplit
2210  DEVICES="$(< /proc/partitions tail -n +3 | awk '{print "/dev/"$4}' | tr "\n" " ")"
2211  DEVICES="$DEVICES $(ls /dev/mapper/*)"
2212  FOUND_DEBNET=""
2213
2214  einfo "Bootoption 'debnet' found. Searching for Debian network configuration: "
2215  eindent
2216  if ! mount | grep '/mnt ' 1>/dev/null 2>&1 ; then
2217     for i in $DEVICES; do
2218      if mount -o ro -t auto "$i" /mnt >/dev/null 2>&1; then
2219          einfo "Scanning on $i"
2220        if [ -f /mnt/etc/network/interfaces ]; then
2221          einfo "/etc/network/interfaces found on ${i}" ; eend 0
2222          FOUND_DEBNET="$i"
2223          break
2224        fi
2225        umount /mnt
2226      fi
2227     done
2228
2229    if [ -n "$FOUND_DEBNET" ]; then
2230      einfo "Stopping network."
2231        pump -k 1>/dev/null 2>&1
2232        /etc/init.d/networking stop 1>/dev/null 2>&1 ; eend $?
2233      einfo "Copying Debian network configuration from $FOUND_DEBNET to running system."
2234        rm -rf /etc/network/run
2235        cp -a /mnt/etc/network /etc
2236        rm -rf /etc/network/run
2237        mkdir /etc/network/run
2238        umount /mnt ; eend $?
2239      einfo "Starting network."
2240        /etc/init.d/networking start ; eend $?
2241    else
2242      eerror "/etc/network/interfaces not found." ; eend 1
2243    fi
2244    eoutdent
2245  else
2246   eerror "Error: /mnt already mounted." ; eend 1
2247  fi
2248 fi
2249 }
2250 # }}}
2251
2252 # {{{ check for broken ipw3945 driver which causes problems (especially on hd install)
2253 config_ipw3945() {
2254   if grep -q ipw3945 /proc/modules ; then
2255      if ! iwconfig 2>/dev/null| grep -qe 'IEEE 802' -qe 'unassociated' ; then
2256         ewarn "Broken ipw3945 network interface found, reloading module."
2257         rmmod ipw3945
2258         modprobe ipw3945
2259         eend $?
2260      fi
2261   fi
2262 }
2263 # }}}
2264
2265 # {{{ disable console blanking
2266 config_blanking(){
2267 if checkbootparam "noblank" ; then
2268   einfo "Bootoption noblank found. Disabling monitor blanking."
2269   setterm -blank 0 ; eend $?
2270 fi
2271 }
2272 # }}}
2273
2274 # {{{ grml2hd: automatic installation
2275 config_grml2hd(){
2276
2277 if stringinstring "BOOT_IMAGE=grml2hd " "$CMDLINE" ; then
2278
2279 if checkbootparam "user" ; then
2280    NEWUSER=''
2281    NEWUSER="$(getbootparam 'user' 2>>$DEBUG)"
2282    sed -i "s/^NEWUSER=.*/NEWUSER=$NEWUSER/" /etc/grml2hd/config || export GRML2HD_FAIL=1
2283 fi
2284
2285 if checkbootparam "filesystem" ; then
2286    FILESYSTEM=''
2287    FILESYSTEM="$(getbootparam 'filesystem' 2>>$DEBUG)"
2288    sed -i "s/^FILESYSTEM=.*/FILESYSTEM=$FILESYSTEM/" /etc/grml2hd/config || export GRML2HD_FAIL=1
2289 fi
2290
2291 if checkbootparam "partition" ; then
2292    PARTITION=''
2293    PARTITION="$(getbootparam 'partition' 2>>$DEBUG)"
2294    # notice: the following checks whether the given partition is available, if not the skip
2295    # execution of grml2hd as it might result in data loss...
2296    if [ -r $PARTITION ] ; then
2297       sed -i "s#^PARTITION=.*#PARTITION=$PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
2298    else
2299       ewarn "Partition $PARTITION does not exist. Skipping execution of grml2hd therefore." ; eend 1
2300    fi
2301 fi
2302
2303 if checkbootparam "mbr" ; then
2304    BOOT_PARTITION=''
2305    BOOT_PARTITION="$(getbootparam 'mbr' 2>>$DEBUG)"
2306    sed -i "s#^BOOT_PARTITION=.*#BOOT_PARTITION=$BOOT_PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
2307 fi
2308
2309 cat>|/usr/bin/grml2hd_noninteractive<<EOF
2310 #!/bin/sh
2311 GRML2HD_NONINTERACTIVE='yes' grml2hd
2312 EOF
2313
2314 chmod 755 /usr/bin/grml2hd_noninteractive
2315 einfo "Bootoption grml2hd found. Running automatic installation via grml2hd using /etc/grml2hd/config." && eend 0
2316 if [ -z "$GRML2HD_FAIL" ] ; then
2317    screen /usr/bin/grml2hd_noninteractive ; einfo "Invoking a shell, just exit to continue booting..." ; /bin/zsh
2318 else
2319    ewarn "There was an error adjusting /etc/grml2hd/config. Skipping execution of grml2hd for security reasons." ; eend 1
2320 fi
2321
2322 fi # if stringinstring "BOOT_IMAGE=grml2hd ...
2323 }
2324 # }}}
2325
2326 # {{{ debootstrap: automatic installation
2327 config_debootstrap(){
2328
2329 if stringinstring "BOOT_IMAGE=debian2hd " "$CMDLINE" ; then
2330
2331 einfo "Bootoption debian2hd found. Setting up environment for automatic installation via grml-debootstrap." ; eend 0
2332
2333 if ! [ -x /usr/sbin/grml-debootstrap ] ; then
2334    eindent
2335    eerror "Bootoption debian2hd found, but grml-debootstrap is not available." ; eend 1
2336    eoutdent
2337    exit 1
2338 fi
2339
2340 if checkbootparam "target" ; then
2341   TARGET=''
2342   TARGET="$(getbootparam 'target' 2>>$DEBUG)"
2343   # notice: the following checks whether the given partition is available, if not the skip
2344   # execution of grml-debootstrap as it might result in data loss...
2345   if ! [ -r "$TARGET" ] ; then
2346      eerror "Target $TARGET does not exist. Skipping execution of grml-debootstrap therefore." ; eend 1
2347   fi
2348 else
2349   eindent
2350   eerror "No bootoption named target found, can not continue execution of grml-debootstrap." ; eend 1
2351   eoutdent
2352   exit 1
2353 fi
2354
2355 if checkbootparam "grub" ; then
2356   GRUB=''
2357   GRUB="$(getbootparam 'grub' 2>>$DEBUG)"
2358 fi
2359
2360 if checkbootparam "groot" ; then
2361   GROOT=''
2362   GROOT="$(getbootparam 'groot' 2>>$DEBUG)"
2363 fi
2364
2365 if checkbootparam "release" ; then
2366   RELEASE=''
2367   RELEASE="$(getbootparam 'release' 2>>$DEBUG)"
2368 fi
2369
2370 if checkbootparam "mirror" ; then
2371   MIRROR=''
2372   MIRROR="$(getbootparam 'mirror' 2>>$DEBUG)"
2373 fi
2374
2375 if checkbootparam "boot_append" ; then
2376   BOOT_APPEND=''
2377   BOOT_APPEND="$(getbootparam 'boot_append' 2>>$DEBUG)"
2378 fi
2379
2380 if checkbootparam "password" ; then
2381   PASSWORD=''
2382   PASSWORD="$(getbootparam 'password' 2>>$DEBUG)"
2383 fi
2384
2385 # now check which options are available
2386 if [ -n "TARGET" ] ; then
2387    TARGETCMD="--target $TARGET"
2388 else
2389    TARGETCMD=''
2390    eindent
2391    eerror "Target not set via bootoption. Skipping execution of grml-debootstrap therefore."; eend 1
2392    eoutdent
2393    exit 1
2394 fi
2395 [ -n "$GRUB" ]     && GRUBCMD="--grub $GRUB"               || GRUBCMD=''
2396 [ -n "$GROOT" ]    && GROOTCMD="--groot $GROOT"            || GROOTCMD=''
2397 [ -n "$RELEASE" ]  && RELEASECMD="--release $RELEASE"      || RELEASECMD=''
2398 [ -n "$MIRROR" ]   && MIRRORCMD="--mirror $MIRROR"         || MIRRORCMD=''
2399 [ -n "$PASSWORD" ] && PASSWORDCMD="--password $PASSWORD"   || PASSWORDCMD=''
2400 [ -n "$BOOT_APPEND" ] && BOOT_APPEND="--boot_append $BOOT_APPEND" || BOOT_APPEND=''
2401
2402 # and finally write script and execute it
2403 cat>|/usr/bin/grml-debootstrap_noninteractive<<EOF
2404 #!/bin/sh
2405 AUTOINSTALL='yes' grml-debootstrap $TARGETCMD $GRUBCMD $GROOTCMD $RELEASECMD $MIRRORCMD $PASSWORDCMD $BOOT_APPEND
2406 EOF
2407
2408 chmod 750  /usr/bin/grml-debootstrap_noninteractive
2409
2410 screen /usr/bin/grml-debootstrap_noninteractive
2411 einfo "Invoking a shell, just exit to continue booting..."
2412 /bin/zsh
2413
2414 fi # stringinstring "BOOT_IMAGE=debian2hd
2415 }
2416 # }}}
2417
2418 # {{{ Support customization
2419 config_distri(){
2420 if checkbootparam "distri"; then
2421   DISTRI="$(getbootparam 'distri' 2>>$DEBUG)"
2422   if [ -r "${LIVECD_PATH}"/desktop/"$DISTRI".jpg ] ; then
2423      [ -n "$BOOTDEBUG" ] && einfo "Debug: bootoption distri found and file ${LIVECD_PATH}/desktop/${DISTRI} present" && eend 0
2424      # make sure the desktop.jpg file is not a symlink, so copying does not file then
2425      [ -L /usr/share/grml/desktop.jpg ] && rm /usr/share/grml/desktop.jpg
2426      cp "${LIVECD_PATH}"/desktop/"$DISTRI".jpg /usr/share/grml/desktop.jpg
2427   fi
2428 fi
2429 }
2430 # }}}
2431
2432 ### {{{ backwards compatible stuff
2433 config_environment(){
2434   ewarn "config_environment is deprecated. Please set CONFIG_ENVIRONMENT in /etc/grml/autoconfig to 'no'." ; eend 0
2435 }
2436 config_keyboard(){
2437   ewarn "config_keyboard is deprecated. Please set CONFIG_KEYBOARD in /etc/grml/autoconfig to 'no'." ; eend 0
2438 }
2439 # }}}
2440
2441 ## END OF FILE #################################################################
2442 # vim:foldmethod=marker expandtab ai ft=zsh shiftwidth=3